#!/bin/sh
# -----------------------------------------------------------------------------
# read out registers of AFE
# -----------------------------------------------------------------------------

switch_hf()
{
	local hf_on=0

	[ $# -ge 1 ] && hf_on=$1
	echo "--------------- switch HF: $hf_on---------------"

	if [ $hf_on = 0 ] ; then
		dwt mem_write 0x09100000 0x108900
	else
		dwt mem_write 0x09100000 0x108901
	fi
}



mode_name=$1
if [ "$mode_name" = "" ] ; then
	echo "Use default mode handset"
	$mode_name="handset"
fi
column=0
case $mode_name in
	"handset")
		echo "Set mode: $mode_name"
		column=4
		;;
	"headset")
		echo "Set mode: $mode_name"
		column=5
		;;
	"dhsg")
		echo "Set mode: $mode_name"
		column=6
		;;
	"handsfree")
		echo "Set mode: $mode_name"
		column=7
		;;
	"handset_ol")
		echo "Set mode: $mode_name"
		column=8
		;;
	"headset_ol")
		echo "Set mode: $mode_name"
		column=9
		;;
	"dhsg_ol")
		echo "Set mode: $mode_name"
		column=10
		;;
	"idle")
		echo "Set mode: $mode_name"
		column=3
		;;
	"usb")
		# not verified
		echo "Set mode: $mode_name"
		column=3
		;;
	"bluetooth")
		# not verified
		echo "Set mode: $mode_name"
		column=3
		;;
esac
if [ $column = 0 ] ; then
	echo "Use default mode Handset"
	mode_name="Handset"
	column=4
fi
INPUTFILE=/css/afe_settings.csv
if [ ! -e $INPUTFILE ] ; then
	echo "Inputfile:$INPUTFILE not exist"
	exit 1
fi
echo "Open $INPUTFILE and set registers from mode: $mode_name"
# for i in $(cut -d "," -f1 $INPUTFILE); do echo $i ; done
for z in $(cat $INPUTFILE)
do
  reg_name=$(echo $z | cut -d"," -f1)
  if [ "$reg_name" != "name" ] ; then
	reg_addr=$(echo $z | cut -d"," -f2)
	reg_val=$(echo $z | cut -d"," -f$column)
	daif write $reg_addr $reg_val
	echo "Write $reg_name @ $reg_addr = $reg_val"
  fi
  # value=$(memtool -32 $reg_addr 1 | grep : | cut -d" " -f3)
done