#!/bin/sh
#Copyright 2018 Gigaset Communications GmbH

source /usr/sbin/maxwell-log-functions
source /etc/dspg-css.conf

test "${DSPG_CSS_DESCRIPTION}" || { log_warning "Variable DSPG_CSS_DESCRIPTION not defined, skipping"; DSPG_CSS_DESCRIPTION="DSPG CSS"; }
test "${DSPG_CSS_LOADER}" || { log_error "Required variable DSPG_CSS_LOADER not defined, skipping"; exit 1; }
test "${DSPG_CSS_STATE_FILE_INVALID_KEYWORD}" || { log_error "Required variable DSPG_CSS_STATE_FILE_INVALID_KEYWORD not defined, skipping"; exit 1; }
test "${DSPG_CSS_STATE_FILE_LOADED_KEYWORD}" || { log_error "Required variable DSPG_CSS_STATE_FILE_LOADED_KEYWORD not defined, skipping"; exit 1; }
test "${MAXWELL_CSS_STATE_FILE}" || { log_error "Required variable MAXWELL_CSS_STATE_FILE not defined, skipping"; exit 1; }

load() {
	echo ${DSPG_CSS_STATE_FILE_INVALID_KEYWORD} > ${MAXWELL_CSS_STATE_FILE}
	(
		exec 1>/var/log/cssload.log
		${DSPG_CSS_LOADER} 2>&1
		while read line; do
			log_info "CSS: ${line}"
		done < /var/log/cssload.log
		if grep -q "$DSPG_CSS_STATE_FILE_LOADED_KEYWORD" "$DSPG_CSS_STATE_FILE"; then
			echo ${DSPG_CSS_STATE_FILE_LOADED_KEYWORD} > ${MAXWELL_CSS_STATE_FILE}
		fi
	) &
}


case "$1" in
	start)
		log_info "Starting / loading ${DSPG_CSS_DESCRIPTION}"
		load
		;;
	restart|force-reload)
		echo "Restarting / reloading ${DSPG_CSS_DESCRIPTION}"
		load
		;;
	*)
		echo "Usage: $0 {start|restart|force-reload}" >&2
		exit 1
		;;
esac

exit 0
