#!/bin/sh
# Copyright 2018 Gigaset Communications GmbH

### BEGIN INIT INFO
# Provides:          logrotate.sh
# Required-Start:    mountall read-only-rootfs-hooks
# Required-Stop:
# Default-Start:     S
# Default-Stop:
# Short-Description: Rotates log created during software update.
# Description:
### END INIT INFO

source /usr/sbin/maxwell-log-functions
source /etc/logrotate.d/logrotate.conf

test -x ${LOGROTATE_BINARY_FILE} || { log_error "Logrotate binary ${LOGROTATE_BINARY_FILE} either not existing or not executable, skipping."; exit 1; }
test -f ${LOGROTATE_UPDATE_CONFIG_FILE} || { log_error "Logrotate config file ${LOGROTATE_UPDATE_CONFIG_FILE} not existing, skipping."; }
test -f ${LOGROTATE_MAXWELL_PANIC_CONFIG_FILE} || { log_error "Logrotate config file ${LOGROTATE_MAXWELL_PANIC_CONFIG_FILE} not existing, skipping."; }
test -f ${LOGROTATE_KERNEL_PANIC_CONFIG_FILE} || { log_error "Logrotate config file ${LOGROTATE_KERNEL_PANIC_CONFIG_FILE} not existing, skipping."; }

LOGROTATE_STATUS_FILE="/var/lib/logrotate-bootup.status"

if [ "$1" == "start" ]; then
    logrotate_config_files=""
    test -f ${UPDATE_LOG_FILE} && logrotate_config_files+=" ${LOGROTATE_UPDATE_CONFIG_FILE}"
    test -f ${KERNEL_PANIC_LOG_FILE} && logrotate_config_files+=" ${LOGROTATE_KERNEL_PANIC_CONFIG_FILE}"
    test -f ${MAXWELL_PANIC_LOG_FILE} && logrotate_config_files+=" ${LOGROTATE_MAXWELL_PANIC_CONFIG_FILE}"
    if [ -n "${logrotate_config_files}" ]; then
        ${LOGROTATE_BINARY_FILE} -fs ${LOGROTATE_STATUS_FILE} ${logrotate_config_files} 2>${LOGROTATE_FAIL_LOG_FILE} && \
            { \
                for logrotate_config_file in ${logrotate_config_files}; do \
                    log_info "Performing logrotate of ${logrotate_config_file}."; \
                done \
            } || \
            { \
                log_error "Logrotate of maxwell / kernel log files failed:"; \
                while read line; do \
                    log_error "${line}"; \
                done < ${LOGROTATE_FAIL_LOG_FILE}; \
            }
    fi
fi
