#!/bin/sh
# Copyright 2018 Gigaset Communications GmbH

source /usr/sbin/maxwell-log-functions
source /etc/bootlog.conf

ROOTFS_OPTIONS_DIR="/etc/default/rootfs-options"
ROOTFS_OPTIONS_TMPFILE="${BOOTLOG_DIR}/rootfs-options.log"

test "$(ls -A ${ROOTFS_OPTIONS_DIR})" == "" && exit 0

shopt -s nullglob

retval=0
exec 2>${ROOTFS_OPTIONS_TMPFILE}
mount -o remount,rw /
mount /config
mount /data
for filepath in ${ROOTFS_OPTIONS_DIR}/*; do
    log_info "Sourcing ${filepath}"
    $(bash -e ${filepath} 1>&2) && rm ${filepath}
    test $? -ne 0 &&
    {
        log_error "Failed executing ${filepath} with following error message:"
        while read line; do
            log_error "$line"
        done < ${ROOTFS_OPTIONS_TMPFILE}
        retval=1
    }
done
umount /
umount /config
umount /data
exit ${retval}
