#!/bin/sh
# Copyright 2016-2018 Gigaset Communications GmbH

### BEGIN INIT INFO
# Provides:          watchdog_daemon
# Required-Start:    $syslog property_service
# Required-Stop:     $syslog property_service
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6 7
# Short-Description: Launches watchdog daemon
# Description:
### END INIT INFO

WATCHDOG_CONFIG_DIR="/etc/watchdog.d"
WATCHDOG_MAXWELL_CONFIG_DIR="${WATCHDOG_CONFIG_DIR}/maxwell"
WATCHDOG_SYSTEM_CONFIG_DIR="${WATCHDOG_CONFIG_DIR}/system"
WATCHDOG_MAXWELL_OVERLAYFS_CONFIG_DIR="/config/appdata${WATCHDOG_CONFIG_DIR}/maxwell"
WATCHDOG_SYSTEM_OVERLAYFS_CONFIG_DIR="/config/appdata${WATCHDOG_CONFIG_DIR}/system"

case "$1" in
	start)
		# To monitor watchdog configuration files changes inotify is used.
		# It doesn't work properly with overlayfs (some events are not reported).
		# that's why inotify should monitor overlayfs directory directly. If directory
		# doesn't exist we touch it to make it.
		if [ ! -d "${WATCHDOG_MAXWELL_OVERLAYFS_CONFIG_DIR}" ]; then
			touch "${WATCHDOG_MAXWELL_CONFIG_DIR}"
		fi

		if [ ! -d "${WATCHDOG_SYSTEM_OVERLAYFS_CONFIG_DIR}" ]; then
			touch "${WATCHDOG_SYSTEM_CONFIG_DIR}"
		fi
		;;
	stop)
		rm /var/run/boot_complete
		;;
	*)
		;;
esac

exit 0
