#!/bin/sh

### BEGIN INIT INFO
# Provides:          tftp_swupdate
# Required-Start:    $syslog
# Required-Stop:     $syslog
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6 7
# Short-Description: Launches TFTP server required by update procedure
# Description:
### END INIT INFO

source /etc/init.d/init-functions

CONFIG_FILE="/etc/firmware-update.conf"
test -f ${CONFIG_FILE} || { log_error "${CONFIG_FILE} does not exist, skipping"; exit 1; }

source ${CONFIG_FILE}

test ${FIRMWARE_UPDATE_ENABLED} || { log_error "Required variable FIRMWARE_UPDATE_ENABLED not defined, skipping"; exit 1; }
test ${FIRMWARE_UPDATE_TFTP_PORT} || { log_error "Required variable FIRMWARE_UPDATE_TFTP_PORT not defined, skipping"; exit 1; }
test ${FIRMWARE_UPDATE_FETCH_UTILITY} || { log_error "Required variable FIRMWARE_UPDATE_FETCH_UTILITY not defined, skipping"; exit 1; }

NAME=firmware-update-tftp
DAEMON=/usr/bin/udpsvd
WORKING_DIR=/var/run/
PIDFILE=${WORKING_DIR}/udpsvd.pid
DAEMON_ARGS=" -vE -c 1 0.0.0.0 ${FIRMWARE_UPDATE_TFTP_PORT} ${FIRMWARE_UPDATE_FETCH_UTILITY}"

test ${FIRMWARE_UPDATE_ENABLED} == 0 && { log_info "Firmware update feature disabled"; exit 0; }

source /etc/init.d/maxwell-init-functions
