#!/bin/sh
#Copyright 2018 Gigaset Communications GmbH

### BEGIN INIT INFO
# Provides:          audio_daemon
# Required-Start:    $syslog property_service_daemon
# Required-Stop:     $syslog property_service_daemon
# Default-Start:     5
# Default-Stop:      0 1 2 3 4 6 7
# Short-Description: Launches Audio daemon
# Description:
### END INIT INFO

source /etc/init.d/init-functions
source /etc/dspg-css.conf

NAME=maxwell-audio
DAEMON=/usr/bin/audio
WORKING_DIR=/var/run/
PIDFILE=${WORKING_DIR}/audio.pid
DAEMON_ARGS="--initial-melody /usr/share/audio/switch_on.wav --parameters-filepath /etc/audio.conf"
USER=root
GROUP=root

test ${MAXWELL_CSS_STATE_FILE} || { log_error "Required variable MAXWELL_CSS_STATE_FILE not defined, skipping"; exit 1; }
test ${DSPG_CSS_STATE_FILE_LOADED_KEYWORD} || { log_error "Required variable DSPG_CSS_STATE_FILE_LOADED_KEYWORD not defined, skipping"; exit 1; }

if [ "$1" == "start" ]; then
   until grep -q "${DSPG_CSS_STATE_FILE_LOADED_KEYWORD}" "${MAXWELL_CSS_STATE_FILE}"; do usleep 100000; done
fi

source /etc/init.d/maxwell-init-functions
