#!/bin/sh
# Copyright 2018 Gigaset Communications GmbH

### BEGIN INIT INFO
# Provides:          Backlight
# Required-Start:
# Required-Stop:
# Default-Start:     5
# Default-Stop:      6 7
# Short-Description: Set display brightness level
# Description:
### END INIT INFO

source /usr/sbin/maxwell-log-functions

BRIGHTNESS_FILE_PATH="/sys/devices/lnk/backlight/brightness"
DEFAULT_BRIGHTNESS=10
STEP_TIME_MICROSEC=30000

function set_brightness
{
	local start_level="$1"
	local end_level="$2"
	local step=1
	[[ $end_level -lt $start_level ]] && step=-1
	for i in $(seq $start_level $step $end_level)
	do
		echo $i > ${BRIGHTNESS_FILE_PATH}
		usleep $STEP_TIME_MICROSEC
	done
}

result=0
brightness=$(propcli get "PhoneUI.Settings.Backlight" --use-nvm)
brightness=${brightness:=${DEFAULT_BRIGHTNESS}}

case "$1" in
	start)
		( set_brightness 0 $brightness ) &
		;;
	stop)
		( set_brightness $brightness 0 ) &
		;;
	*)
		log_error "Improper parameter value."
		result=1
		;;
esac

exit $result
