#!/bin/sh

### BEGIN INIT INFO
# Provides:          mosquitto daemon
# Required-Start:    syslog network-loopback
# Required-Stop:
# Default-Start:     S
# Default-Stop:      0 6 7
# Short-Description: Launches Mosquitto MQTT broker
# Description:
### END INIT INFO

. /etc/init.d/init-functions

if [ -f /var/lock/develop.lck ]; then
    MOSQUITTO_CONF=/etc/mosquitto/mosquitto-develop.conf
else
    MOSQUITTO_CONF=/etc/mosquitto/mosquitto-default.conf
fi

MOSQUITTO_LOG=/var/log/mosquitto.log
MOSQUITTO_HOME=/var/lib/mosquitto
MOSQUITTO_USER=mqtt

if [ -f ${MOSQUITTO_LOG} ]; then
    USER=`stat -c '%U' ${MOSQUITTO_LOG}`
    if [ "${USER}" != "${MOSQUITTO_USER}" ]; then
        chown ${MOSQUITTO_USER} ${MOSQUITTO_LOG}
    fi
else
    touch ${MOSQUITTO_LOG}
    chown ${MOSQUITTO_USER} ${MOSQUITTO_LOG}
fi

if [ ! -d "${MOSQUITTO_HOME}" ]; then
    mkdir ${MOSQUITTO_HOME}
    chown ${MOSQUITTO_USER} ${MOSQUITTO_HOME}
fi

NAME=mosquitto
DAEMON=/usr/sbin/mosquitto
WORKING_DIR=/var/run/
PIDFILE=${WORKING_DIR}/mosquitto.pid
DAEMON_ARGS="${DAEMON_ARGS} -c ${MOSQUITTO_CONF}"

. /etc/init.d/maxwell-init-functions
