#!/bin/sh
# Copyright 2018 Gigaset Communications GmbH

source /usr/sbin/maxwell-log-functions

SYSCTL_CONFIG_FILE="/etc/sysctl.conf"
SYSCTL_BINARY_FILE="/sbin/sysctl"

test -f ${SYSCTL_CONFIG_FILE} || { log_error "Sysctl config file ${SYSCTL_CONFIG_FILE} not existing, skipping"; exit 1; }
test -x ${SYSCTL_BINARY_FILE} || { log_error "Sysctl binary ${SYSCTL_BINARY_FILE} either not existing or not executable, skipping"; exit 1; }

output=$(${SYSCTL_BINARY_FILE} -p ${SYSCTL_CONFIG_FILE})

IFS=$'\n'
test -n "${output}" &&
(
    log_info "Applying sysctl configuration from ${SYSCTL_CONFIG_FILE}:"
    for line in ${output}; do
        log_info "    ${line}"
    done
)
