#!/bin/sh
### BEGIN INIT INFO
# Provides:          maxwell-coredumps.sh
# Required-Start:
# Required-Stop:     umountnfs
# Default-Start:     S
# Default-Stop:      6 7
# Short-Description: Stop core dumps during system reboot
# Description:
### END INIT INFO

PATH=/sbin:/bin:/usr/sbin:/usr/bin
CORE_DUMPS_DIR="/config/crash"


case "$1" in
    start)
        ;;
    stop)
        killall coredump
        # Remove all dumps which are not finished
        if [ -d "$CORE_DUMPS_DIR" ]; then
            rm -rf "$CORE_DUMPS_DIR"/*.dump
        fi
        # Stop coredumps before kill signals are sent
        sysctl -w kernel.core_pattern=core
        ;;
    *)
        log_info "Usage is: $0 {start|stop}" >&2
        exit 1
        ;;
esac

exit 0
