#!/bin/sh
kernel=$1
number=$2
devpath=$3
major=$4
minor=$5
id=$6

dbg=0
log_file=/data/alsa_snd.info
if [ $dbg -ne 0 ] ; then
	echo "$ACTION something" >> $log_file ;
	date >> $log_file ;
	echo "kernel:$kernel" >> $log_file ;
	echo "number:$number" >> $log_file ;
	echo "devpath:$devpath" >> $log_file ;
	echo "id:$id" >> $log_file ;
	echo "major:$major" >> $log_file ;
	echo "minor:$minor" >> $log_file ;
fi
# cat /proc/bus/input/devices
# known USB input devices:

# /dev/input/event0: USB_OC_DET
# 400000.usb
# -> /dev/input/usb_oc_det

# /dev/input/event1: DSPG keypad
# 50002b0.keypad
# -> /dev/input/keypad

# /dev/input/event2: DSPG hookswitch
# hookswitch
# -> /dev/input/hookswitch

# /dev/input/event3: Logitech Logitech USB Headset
# 300000.usb/usb1
# -> /dev/input/usb_headset

# /dev/input/event4: dspg-dvf99-css Headset Jack
# snd-dvf99-mach-drv
# -> /dev/input/corded_headset


### 1.) check devpath
if [ "$devpath" = "" ] ; then
	[ $dbg -ne 0 ] && echo "devpath: >$devpath< is missing!"  >> $log_file ;
	exit 0
fi
### 2.) get card id
# id could be the same than card_id
card_id=$(echo "$devpath" | sed -n 's/.*\(card[0-9][0-9]*\).*/\1/p')
### 3.a) check if it is an USB sound device
device_type=$kernel
found=0
# "snd-dvf99-mach-drv" "400000.usb" "300000.usb"
### check if it is an USB sound device
if [ $found = 0 ] ; then
	substring="400000.usb"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="usb_headset"
		echo -n $device_type > /sys$devpath/device/id
		found=1
	fi
fi
if [ $found = 0 ] ; then
	substring="300000.usb"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="usb_headset"
		echo -n $device_type > /sys$devpath/device/id
		found=1
	fi
fi
### check if it is a dvf99 sound device
if [ $found = 0 ] ; then
	substring="snd-dvf99-mach-drv"
	if [  "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="on_board"
		# echo -n $device_type > /sys$devpath/device/id
		found=1
	fi
fi
###
### check if it is a dvf99 bluetooth sound device
if [ $found = 0 ] ; then
	substring="dvf99-bt-mach-drv"
	if [  "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="bluetooth"
		# echo -n $device_type > /sys$devpath/device/id
		found=1
	fi
fi
###

if [ "$ACTION" = "add" ] ; then
	[ $dbg -ne 0 ] && echo "$ACTION $card_id" >> $log_file ;
	
fi
if [ "$ACTION" = "remove" ] ; then
	[ $dbg -ne 0 ] && echo "$ACTION $event_id" >> $log_file ;
fi
echo $device_type
[ $dbg -ne 0 ] && echo "Link $device_type" >> $log_file ;
[ $dbg -ne 0 ] && echo "done!" >> $log_file ;
exit 0

# $kernel, %k
#
#     The kernel name for this device.
# $number, %n
#
#     The kernel number for this device. For example, "sda3" has kernel number "3".
# $devpath, %p
#
#     The devpath of the device.
# $id, %b
#
#     The name of the device matched while searching the devpath upwards for SUBSYSTEMS, KERNELS, DRIVERS, and ATTRS.
# $driver
#
#     The driver name of the device matched while searching the devpath upwards for SUBSYSTEMS, KERNELS, DRIVERS, and ATTRS.
# $attr{file}, %s{file}
#
#     The value of a sysfs attribute found at the device where all keys of the rule have matched. If the matching device does not have such an attribute, and a previous KERNELS, SUBSYSTEMS, DRIVERS, or ATTRS test selected a parent device, then the attribute from that parent device is used.
#
#     If the attribute is a symlink, the last element of the symlink target is returned as the value.
# $env{key}, %E{key}
#
#     A device property value.
# $major, %M
#
#     The kernel major number for the device.
# $minor, %m
#
#     The kernel minor number for the device.
# $result, %c
#
#     The string returned by the external program requested with PROGRAM. A single part of the string, separated by a space character, may be selected by specifying the part number as an attribute: "%c{N}". If the number is followed by the "+" character, this part plus all remaining parts of the result string are substituted: "%c{N+}".
# $parent, %P
#
#     The node name of the parent device.
# $name
#
#     The current name of the device. If not changed by a rule, it is the name of the kernel device.
# $links
#
#     A space-separated list of the current symlinks. The value is only set during a remove event or if an earlier rule assigned a value.
# $root, %r
#
#     The udev_root value.
# $sys, %S
#
#     The sysfs mount point.
