#!/bin/sh
#
# Copyright (C) 2018 Gigaset Communications GmbH
#

kernel=$1
number=$2
devpath=$3
major=$4
minor=$5
id=$6

dbg=1
log_file=/var/log/eventinput.log
if [ $dbg -ne 0 ] ; then
	echo "$ACTION something" >> $log_file ;
	date >> $log_file ;
	echo "kernel:$kernel" >> $log_file ;
	echo "number:$number" >> $log_file ;
	echo "devpath:$devpath" >> $log_file ;
	echo "id:$id" >> $log_file ;
	echo "major:$major" >> $log_file ;
	echo "minor:$minor" >> $log_file ;
fi
# cat /proc/bus/input/devices
# known USB input devices:

# /dev/input/event0: USB_OC_DET
# 400000.usb or 300000.usb
# -> /dev/input/usb_oc_det

# /dev/input/event1: DSPG keypad
# 50002b0.keypad
# -> /dev/input/keypad

# /dev/input/event2: DSPG hookswitch
# hookswitch
# -> /dev/input/hookswitch

# /dev/input/event3: Logitech Logitech USB Headset
# 300000.usb/usb1
# -> /dev/input/usb_headset

# /dev/input/event4: dspg-dvf99-css Headset Jack
# snd-dvf99-mach-drv
# -> /dev/input/corded_headset

### 1.) check devpath
if [ "$devpath" = "" ] ; then
	[ $dbg -ne 0 ] && echo "devpath: >$devpath< is missing!"  >> $log_file ;
	exit 0
fi
### 2.) get event id
# number should be the same than event_id
event_id=$(echo "$devpath" | sed -n 's/.*\(event[0-9][0-9]*\).*/\1/p')
### 3.a) check if it is an USB sound device
device_type=$kernel
found=0
# "50002b0.keypad" "hookswitch" "snd-dvf99-mach-drv" "400000.usb" "300000.usb"
if [ $found = 0 ] ; then
	substring="50002b0.keypad"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="keypad"
		found=1
	fi
fi
if [ $found = 0 ] ; then
	substring="hookswitch"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="hookswitch"
		found=1
	fi
fi
if [ $found = 0 ] ; then
	# /devices/platform/snd-dvf99-mach-drv/sound/card1/input12/event5
	substring="snd-dvf99-mach-drv"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="corded_headset"
		# remove that stuff, it was just for testing and it is not a real device
		# if [ "$ACTION" = "add" ] ; then
		# 	if [ ! -e /dev/corded_headset ]; then
		# 		mkdir -p /dev/$device_type/
		# 		# /sys/devices/platform/snd-dvf99-mach-drv/switches/jack
		# 		ln -fs /sys$devpath/../../../../switches/ /dev/$device_type/
		# 		[ $dbg -ne 0 ] && echo "Create /dev/$device_type" >> $log_file ;
		# 	fi
		# fi
		# if [ "$ACTION" = "remove" ] ; then
		# 	if [ -e /dev/corded_headset ]; then
		# 		rm -Rf /dev/$device_type/
		# 	fi
		# fi
		found=1
	fi
fi
if [ $found = 0 ] ; then
	substring="maxwell_power"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="usb_oc_det"
		found=1
	fi
fi
if [ $found = 0 ] ; then
	substring="400000.usb"
	# /devices/platform/usb/usb:usb-phy-mux/usb:usb-phy-mux:usb-host-block-reset/usb:usb-phy-mux:usb-host
	# -block-reset:usb-host-blocks/400000.usb/usb2/2-1/2-1:1.0/sound/card0/controlC0
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="usb_headset"
		fi
fi
if [ $found = 0 ] ; then
	substring="300000.usb"
	# /devices/platform/usb/usb:usb-phy-mux/usb:usb-phy-mux:usb-host-block-reset/usb:usb-phy-mux:usb-host
	# -block-reset:usb-host-blocks/400000.usb/usb2/2-1/2-1:1.0/sound/card0/controlC0
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="usb_headset"
		fi
fi
if [ $found = 0 ] ; then
	substring="6100000.i2c/i2c-0/0-0055"
	if [ "${devpath/$substring}" = "$devpath" ] ; then
		[ $dbg -ne 0 ] && echo "${substring} is not in ${devpath}"  >> $log_file ;
	else
		[ $dbg -ne 0 ] && echo "${substring} was found in ${devpath}"  >> $log_file ;
		device_type="touch"
		found=1
	fi
fi
###
if [ "$ACTION" = "add" ] ; then
	[ $dbg -ne 0 ] && echo "$ACTION $event_id" >> $log_file ;
fi
if [ "$ACTION" = "remove" ] ; then
	[ $dbg -ne 0 ] && echo "$ACTION $event_id" >> $log_file ;
fi
echo $device_type
[ $dbg -ne 0 ] && echo "Link $device_type" >> $log_file ;
[ $dbg -ne 0 ] && echo "done!" >> $log_file ;
exit 0

# $kernel, %k
#
#     The kernel name for this device.
# $number, %n
#
#     The kernel number for this device. For example, "sda3" has kernel number "3".
# $devpath, %p
#
#     The devpath of the device.
# $id, %b
#
#     The name of the device matched while searching the devpath upwards for SUBSYSTEMS, KERNELS, DRIVERS, and ATTRS.
# $driver
#
#     The driver name of the device matched while searching the devpath upwards for SUBSYSTEMS, KERNELS, DRIVERS, and ATTRS.
# $attr{file}, %s{file}
#
#     The value of a sysfs attribute found at the device where all keys of the rule have matched. If the matching device does not have such an attribute, and a previous KERNELS, SUBSYSTEMS, DRIVERS, or ATTRS test selected a parent device, then the attribute from that parent device is used.
#
#     If the attribute is a symlink, the last element of the symlink target is returned as the value.
# $env{key}, %E{key}
#
#     A device property value.
# $major, %M
#
#     The kernel major number for the device.
# $minor, %m
#
#     The kernel minor number for the device.
# $result, %c
#
#     The string returned by the external program requested with PROGRAM. A single part of the string, separated by a space character, may be selected by specifying the part number as an attribute: "%c{N}". If the number is followed by the "+" character, this part plus all remaining parts of the result string are substituted: "%c{N+}".
# $parent, %P
#
#     The node name of the parent device.
# $name
#
#     The current name of the device. If not changed by a rule, it is the name of the kernel device.
# $links
#
#     A space-separated list of the current symlinks. The value is only set during a remove event or if an earlier rule assigned a value.
# $root, %r
#
#     The udev_root value.
# $sys, %S
#
#     The sysfs mount point.


# root@max4:/# cat /proc/bus/input/devices
# I: Bus=0019 Vendor=0001 Product=0001 Version=0100
# N: Name="DSPG keypad"
# P: Phys=50002b0.keypad
# S: Sysfs=/devices/platform/50002b0.keypad/input/input0
# U: Uniq=
# H: Handlers=kbd event0
# B: PROP=0
# B: EV=3
# B: KEY=8e3781 0 40180 92000ffc
#
# I: Bus=0019 Vendor=0001 Product=0002 Version=0100
# N: Name="DSPG hookswitch"
# P: Phys=hookswitch
# S: Sysfs=/devices/platform/hookswitch/input/input1
# U: Uniq=
# H: Handlers=kbd event1
# B: PROP=0
# B: EV=3
# B: KEY=60
#
# I: Bus=0018 Vendor=0000 Product=0000 Version=0000
# N: Name="SITRONIX"
# P: Phys=
# S: Sysfs=/devices/platform/6100000.i2c/i2c-0/0-0055/input/input2
# U: Uniq=
# H: Handlers=event2
# B: PROP=0
# B: EV=b
# B: KEY=400 0 0 0 0 0 0 0 0 0 0
# B: ABS=3e50000 1000003
#
# I: Bus=0000 Vendor=0000 Product=0000 Version=0000
# N: Name="USB_OC_DET"
# P: Phys=usb/input0
# S: Sysfs=/devices/platform/maxwell_power/input/input4
# U: Uniq=
# H: Handlers=kbd event3
# B: PROP=0
# B: EV=3
# B: KEY=100000 0 0 0
#
# I: Bus=0000 Vendor=0000 Product=0000 Version=0000
# N: Name="dspg-dvf99-css Headset Jack"
# P: Phys=ALSA
# S: Sysfs=/devices/platform/snd-dvf99-mach-drv/sound/card0/input5
# U: Uniq=
# H: Handlers=event4
# B: PROP=0
# B: EV=23
# B: KEY=7 0 0 0 0 0 0 0 0
# B: SW=14
