#!/bin/sh

### BEGIN INIT INFO
# Provides:          maxwell_model
# Required-Start:
# Required-Stop:
# Default-Start:     5
# Default-Stop:
# Short-Description: Prints device model info
# Description:
### END INIT INFO

source /usr/sbin/maxwell-log-functions

board=$(cut -d" " -f3,4 < /proc/device-tree/model)
base_model="${board} PRO"
case $board in
	"Maxwell Basic")
		variant_model="elmeg IP620"
		;;
	"Maxwell 2")
		variant_model="elmeg IP625"
		;;
	"Maxwell 3")
		variant_model="elmeg IP630"
		;;
	"Maxwell 4")
		variant_model="elmeg IPXXX"
		;;
	*)
		log_error "Not recognized device model: ${board}"
		exit 1
		;;
esac

model=$(tee /etc/model <<< "${base_model}:${variant_model}")
log_info ${model}
echo ${model}
