#!/bin/bash

# Copyright 2018 Gigaset Communications GmbH

IPTABLE_NAME="dnsroot"

delete_rules()
{
	RULE="OUTPUT -j ${IPTABLE_NAME}"
	while [ true ]; do
		$(iptables -w -C ${RULE} &>/dev/null)
		if [ $? -eq 0 ]; then
			$(iptables -w -D ${RULE})
		else
			break
		fi
	done
}

# Delete links to IP table
delete_rules

# Delete table
iptables -X ${IPTABLE_NAME}

# Recreate table
iptables -w -N ${IPTABLE_NAME}

if [ "$1" == "Disabled" ]; then
	iptables -A ${IPTABLE_NAME} -p udp --dport 53 -m u32 --u32 "0x28=0x0100" -j DROP
fi

iptables -w -A OUTPUT -j ${IPTABLE_NAME}
