#!/bin/bash
# Copyright 2018 Gigaset Communications GmbH

source /usr/sbin/maxwell-log-functions

PROPCLI="/usr/bin/propcli"

update_ntp_last_synchronization_timestamp()
{
	local last_sync_sec=$1
	if [[ ${last_sync_sec} =~ ^[0-9]+$ ]]; then
		local current_timestamp=$(date +%s)
		local last_sync_timestamp="$(( ${current_timestamp} - ${last_sync_sec} ))"
		log_info "Updating NTP last synchronization timestamp"
		${PROPCLI} set State.NTPLastSync ${last_sync_timestamp}
	else
		log_error "Failed aquiring valid NTP last sync value [last_sync_sec=${last_sync_sec}]"
	fi
}

repeat_periodically()
{
	local synchronization_period_sec=120
	while [ true ]
	do
		sleep ${synchronization_period_sec}
		local last_sync_col='$5'
		local last_sync_sec=$(ntpq -p | awk "/^\*/ {print ${last_sync_col}}")
		update_ntp_last_synchronization_timestamp ${last_sync_sec}
	done
}

repeat_periodically
