#!/bin/bash
# Copyright 2016-2018 Gigaset Communications GmbH

LOCK_DIR="/var/run/lock/wd_restart_all.lck"
CONFIG_FILES_PATH="/etc/watchdog.d/maxwell"
START_ARRAY=()
STOP_ARRAY=()

# Use mkdir (which is atomic) to avoid multiple script instances
mkdir "${LOCK_DIR}" 2>/dev/null
if [ $? -ne 0 ]; then
	exit 1
fi

for config_file in $(ls ${CONFIG_FILES_PATH}/*.conf); do
	START_ARRAY+=("$(cat $config_file | cut -d ',' -f 3)")
done

# Apps are stopped in reverse order
for config_file in $(ls -r ${CONFIG_FILES_PATH}/*.conf); do
	STOP_ARRAY+=("$(cat $config_file | cut -d ',' -f 2)")
done

for stop in "${STOP_ARRAY[@]}"; do
	sh -c "$stop"
done

for start in "${START_ARRAY[@]}"; do
	sh -c "$start"
done

rmdir "${LOCK_DIR}"
