<!DOCTYPE html>
<html ng-app="WebUI" ng-controller="MainCtrl" data-browser="{{bowser.name}}" data-browser-version="{{bowser.version}}">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=Edge">

        <title ng-bind="parameters.PhoneName.value"></title>

        <script src="js/lib/jquery-2.1.4.min.js"></script>
        <script src="js/lib/angular.min.js"></script>
        <script src="js/lib/angular-route.min.js"></script>
        <script src="js/lib/angular-messages.min.js"></script>
        <script src="js/lib/angular-animate.min.js"></script>
        <script src="js/lib/bootstrap.min.js"></script>
        <script src="js/lib/bootstrap-select.min.js"></script>
        <script src="js/lib/nya-bootstrap-select.js"></script>
        <script src="js/lib/angular-file-upload.min.js"></script>
        <script src="js/lib/ui-bootstrap-tpls-0.13.4.min.js"></script>
        <script src="js/lib/bowser.min.js"></script>
        <script src="js/lib/FileSaver.min.js"></script>
        <script src="js/lib/moment.min.js"></script>
        <script src="js/lib/moment-timezone-with-data.min.js"></script>
        <script src="js/app.js"></script>
        <script src="js/controllers.js"></script>
        <script src="js/filters.js"></script>
        <script src="js/services.js"></script>
        <script src="js/directives.js"></script>
        <script src="js/lib/eventsource.min.js"></script>
        <link rel="stylesheet" href="css/style.css">

        <link rel="stylesheet" ng-if="parameters.Variant.value" ng-href="css/{{parameters.Variant.value}}/lib/bootstrap.min.css">
        <link rel="stylesheet" ng-if="parameters.Variant.value" ng-href="css/{{parameters.Variant.value}}/lib/bootstrap-theme.min.css">
        <link rel="stylesheet" ng-if="parameters.Variant.value" ng-href="css/{{parameters.Variant.value}}/lib/bootstrap-select.min.css">
        <link rel="stylesheet" ng-if="parameters.Variant.value" ng-href="css/{{parameters.Variant.value}}/lib/awesome-bootstrap-checkbox.css">
        <link rel="stylesheet" ng-if="parameters.Variant.value" ng-href="css/{{parameters.Variant.value}}/style.css">

        <link rel="icon" ng-if="parameters.Variant.value" ng-href="img/{{parameters.Variant.value}}/favicon.ico" type="image/x-icon">
        <link rel="shortcut icon" ng-if="parameters.Variant.value" ng-href="img/{{parameters.Variant.value}}/favicon.ico" type="image/x-icon">
    </head>

    <body>
        <div id="browser-not-supported">
        <!--<php
            //@include_once './conf/conf.php';
            //require_once '../backend/conf/conf.php';
            //define('BACKENDPATH', '/www/pages/backend');
            //require '../backend/conf/autoloader.php';
            //$set = new settingscontroller();
            //$set->settingsGetText('BrowserIsNotSupported');
        ?>-->
        </div>

        <div class="container">
            <div id="header" class="row">
                <img class="pull-right" ng-src="img/{{parameters.Variant.value}}/logo.png">
            </div>
            <div id="tabs" class="row">
                <div ng-if="activeMenu.length > 0">
                    <div class="col-xs-2 no-gutter"
                         ng-repeat="menuItem in menu.menu"
                         ng-if="::checkMenuCondition(menuItem, 'showIf')"
                         ng-class="{activeTab: $index === activeMenu[0] && !activeMenu.profilePage}"
                         ng-hide="$index === 2 && $index !== activeMenu[0]">
                        <a ng-href="{{checkMenuCondition(menuItem, 'enableIf') ? menuItem.url : '#'}}">
                            <span ng-class="menuItem.icon"></span>
                            <span ng-bind="text[menuItem.text]"></span>
                        </a>
                    </div>
                    <span id="userMenu" class="pull-right" dropdown>
                        <a id="linkProfile">
                            <span class="glyphicon glyphicon-user"></span>
                        </a>
                        <ul class="dropdown-menu">
                            <li ng-repeat="menuItem in menu.profile"
                                ng-if="::checkMenuCondition(menuItem, 'showIf')"
                                ng-class="{disabled: !checkMenuCondition(menuItem, 'enableIf')}">
                                <a id="linkProfileItem{{$index}}" ng-href="{{checkMenuCondition(menuItem, 'enableIf') ? menuItem.url : '#'}}">
                                    <span ng-bind="text[menuItem.text]"></span>
                                </a>
                            </li>
                            <li class="divider"></li>
                            <li>
                                <a id="linkLogout" ng-click="logout()">
                                    <span ng-bind="text.Logout"></span>
                                </a>
                            </li>
                        </ul>
                    </span>
                </div>
            </div>
            <div class="row">
                <div class="col-xs-4" id="nav" ng-if="activeMenu.length > 0">
                    <ul class="list-unstyled">
                        <li ng-repeat="menuItem in menu.menu[activeMenu[0]].menu" ng-if="::checkMenuCondition(menuItem, 'showIf')">
                            <a ng-href="{{checkMenuCondition(menuItem, 'enableIf') ? menuItem.url : '#'}}"
                               ng-class="{activeMenu: $index === activeMenu[1] && !activeMenu.profilePage}"
                               ng-click="cancelForm(menuItem)">
                                <span ng-class="menuItem.icon"></span>
                                <span ng-bind="text[menuItem.text]"></span>
                                <span class="glyphicon btn-xs" ng-class="{
                                    'glyphicon-chevron-right': $index !== activeMenu[1] || !menuItem.menu,
                                    'glyphicon-chevron-down': $index === activeMenu[1] && menuItem.menu
                                }"></span>
                            </a>
                            <ul class="list-unstyled" ng-if="menuItem.menu && $index === activeMenu[1]">
                                <li ng-repeat="subMenuItem in menuItem.menu" ng-if="::checkMenuCondition(subMenuItem, 'showIf')">
                                    <a ng-href="{{checkMenuCondition(menuItem, 'enableIf') && checkMenuCondition(subMenuItem, 'enableIf') ? subMenuItem.url : '#'}}"
                                       ng-class="{activeSubmenu: $index === activeMenu[2] && !activeMenu.profilePage}"
                                       ng-click="cancelForm(subMenuItem)">
                                        <span ng-class="subMenuItem.icon"></span>
                                        <span ng-bind="text[subMenuItem.text]"></span>
                                    </a>
                                  <ul class="list-unstyled" ng-if="subMenuItem.menu && $index === activeMenu[2] && isExtensionModuleEnabled()">
                                    <li ng-repeat="subMenuItem1 in subMenuItem.menu" ng-if="::checkMenuCondition(subMenuItem1, 'showIf')">
                                        <a ng-href="{{checkMenuCondition(subMenuItem1, 'enableIf') && checkMenuCondition(subMenuItem1, 'enableIf') ? subMenuItem1.url : '#'}}"
                                          ng-class="{activeSubmenu: $index === activeMenu[3] && !activeMenu.profilePage}" ng-if="state['ExtensionBoard.'+ $index +'.Status']"
                                          ng-click="cancelForm(subMenuItem1)">
                                            <span ng-class="subMenuItem1.icon"></span>
                                            <span ng-bind="text[subMenuItem1.text]"></span>
                                        </a>
                                      <ul class="list-unstyled">
                                      </ul>
                                    </li>
                                  </ul>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
                <div class="col-xs-4" id="picture" ng-if="activeMenu.length === 0">
                    <img class="center-block" ng-src="img/{{parameters.Variant.value}}/{{getPictureName()}}">
                </div>
                <div class="col-xs-8" id="view" ng-view></div>
            </div>
        </div>
    </body>
</html>