angular.module('WebUI').directive('disableContents', ['$compile', function ($compile) {
    return {
        restrict: 'EAC',
        link: function (scope, element, attrs, controller) {
            var inputs = element.find('input');
            var a = element.find('a');

            inputs.attr('ng-disabled', attrs['disableContents']);
            a.attr('ng-disabled', attrs['disableContents']);

            $compile(element.contents())(scope);
        }
    };
}]);

angular.module('WebUI').directive('blurOnFocus', ['$compile', function ($compile) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs, controller) {
            element.on('focus', function () {
                element.blur();
            });

            var inputs = element.find('input');
            inputs.bind('focus', function (event) {
                event.target.blur();
            });

            $compile(element.contents())(scope);
        }
    };
}]);

angular.module('WebUI').directive('equal', [function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attrs, model) {
            var otherInput = element.inheritedData('$formController')[attrs['equal']];

            scope.$watch(function () {
                return otherInput.$viewValue;
            }, function () {
                model.$validate();
            });

            model.$validators.equal = function (modelValue, viewValue) {
                return angular.equals(otherInput.$viewValue, viewValue);
            };
        }
    };
}]);

angular.module('WebUI').directive('overflowEllipsis', [function () {
    return {
        restrict: 'C',
        link: function (scope, element, attrs, controller) {
            scope.$watch(function () {
                return element[0].scrollWidth > element[0].clientWidth;
            }, function (newValue, oldValue) {
                var text = element.text().trim();

                if (newValue && text.length > 0) {
                    element.attr('title', text);
                } else {
                    element.removeAttr('title');
                }
            });
        }
    };
}]);

angular.module('WebUI').directive('hideZero', function() {
    return {
        link: function(scope, element, attr, Model) {
            scope.$watch(attr.ngModel, function() {
                if (element[0].value == '0') {
                    element[0].value = scope.$parent.$parent.$parent.text.FileNoUploaded;
                } else {
                    element[0].value = scope.$parent.$parent.$parent.text.FileUploaded;
                }
            }, true);
        }
    };
});
