<?php

class AccountManager
{
    private $nvm;
    private $paramsToDelete;
    private $user;

    public function AccountManager($_user) {
        $this->nvm = new settingscontroller();
        $this->paramsToDelete = [];
        $this->user = $_user;
    }

    public function deleteAccount($accountID){
        $paramsArray = $this->getParamsArrayToDelete($accountID);
        echo json_encode(array('defaultAccount' => $this->getDefaultAccount($accountID)));
        $this->nvm->settingsResetVlist($paramsArray);

    }

    private function getParamsArrayToDelete($accountID){
        array_push($this->paramsToDelete, SIP_ACCOUNT_PREFIX . $accountID . ".%");
        array_push($this->paramsToDelete, CALL_DIVERT_PREFIX . $accountID . ".%");
        $this->paramsToDelete = array_merge($this->paramsToDelete, $this->getDiallingPlansToRemove($accountID));
        return $this->paramsToDelete;
    }

    private function getDiallingPlansToRemove($accountID){
        $paramsArray = array(DIALLING_PLANS_PREFIX . "%");
        $diallingPlansArray = $this->nvm->settingsGetVListArray($paramsArray, $this->user);
        $indexesArray = $this->getIndexesOfDiallingPlansRelatedWithAccount($diallingPlansArray,$accountID);

        return $this->createDiallingPlansToRemove($indexesArray);

    }

    private function getIndexesOfDiallingPlansRelatedWithAccount($diallingPlansArray, $accountID){
        $tmpArray = [];

        foreach ($diallingPlansArray['DiallingPlans'] as $key => $diallingPlan ){
            if ($diallingPlan['Active']['value'] == 1 &&  $diallingPlan['Connection']['value'] == $accountID){
                array_push($tmpArray, $key);
            }
        }
        return $tmpArray;
    }

    private function createDiallingPlansToRemove($indexesArray){
        $dialingPlansParameterNames = [];
        foreach ($indexesArray as $index){
            array_push($dialingPlansParameterNames, DIALLING_PLANS_PREFIX . $index . ".%");
        }
        return $dialingPlansParameterNames;
    }

    private function getDefaultAccount($accountID){
        $sipAccountArray = $this->nvm->settingsGetVListArray(['SIP.Account.%'],$this->user)['SIP'];
        $newDefaultAccount = 0;

        for($index = 0; $index < getSIPAccountsCounts(); $index++ ){
            if($sipAccountArray[$index]['Active']['value'] == '1' && $index != $accountID){
                $newDefaultAccount = $index;
                break;
            }
        }
        $paramsArray = array("SIP.DefaultAccount" => $newDefaultAccount);
        $this->nvm->settingsSetVlist($paramsArray);
        return $newDefaultAccount;
    }
}