<?php

class downloadfile
{

  /**
   * Method upload file from PC to destination directory
   * 
   * @param type $_file - Global array $_FILES 
   * @param type $_destinationPath - destination path where file will be copies from tmp directory
   * @return boolean
   */
  public function DownloadFromPC($_file, $_destinationPath)
  {
    try
    {
      if (move_uploaded_file($_file['file']['tmp_name'], $_destinationPath . DIRECTORY_SEPARATOR . $_file['file']['name']))
      {
        return $this->CheckFileIsCopied($_destinationPath, $_file['file']['name']);
      }
      else
      {
        return false;
      }
    }
    catch (Exception $exc)
    {
      return false;
    }
  }

  function fileNewName($_path, $_filename)
  {
    if ($pos = strrpos($_filename, '.'))
    {
      $name = substr($_filename, 0, $pos);
      $ext = substr($_filename, $pos);
    }
    else
    {
      $name = $_filename;
    }

    $newpath = $_path . '/' . $_filename;
    $newname = $_filename;
    $counter = 0;
    while (file_exists($newpath))
    {
      $newname = $name . '_' . $counter . $ext;
      $newpath = $_path . '/' . $newname;
      $counter++;
    }

    return $newname;
  }

  public function uploadFileFromPcWithRename($_file, $_destinationPath, &$filename, $_replacestring = null)
  {
    try
    {
      if ($_replacestring != null)
      {
        $_file['file']['name'] = preg_replace("/[^A-Za-z0-9_\.]/", "_", $_file['file']['name']);
      }

      $_file['file']['name'] = $this->fileNewName($_destinationPath, $_file['file']['name']);
      $filename = $_file['file']['name'];
      return $this->DownloadFromPC($_file, $_destinationPath);
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  public function uploadFileFromPCWithFilters($_file, $_destinationPath, $_filters = null, $_rename = null, $_replace = null)
  {
    if ($_filters !== null)
    {
      foreach ($_filters as $key => $val)
      {

        if ($key == 'filesize')
        {
          if (isset($_filters['filesize']['condition']) && $_filters['filesize']['condition'] == 'lt')
          {
            if ($_file['file']['size'] <= $_filters['filesize']['value'])
            {
              $result = array('action' => '#fileok#');
            }
            else
            {
              $result = array('action' => '#filesize#');
              break;
            }
          }
        }

        if ($key == 'mimetype')
        {
          if (in_array($_file['file']['type'], $_filters['mimetype']))
          {
            $result = array('action' => '#fileok#');
          }
          else
          {
            $result = array('action' => '#mimetype#');
            break;
          }
        }
      }

      if ($result['action'] == '#fileok#')
      {
        $result = $this->uploadFiles($_file, $_destinationPath, $_filters, $_rename, $_replace);
      }
    }
    else
    {
      $result = $this->uploadFiles($_file, $_destinationPath, $_filters, $_rename, $_replace);
    }

    return $result;
  }

  private function uploadFiles($_file, $_destinationPath, $_filters = null, $_rename = null, $_replace = null)
  {
    if ($_rename == true)
    {

      if ($_replace != null)
      {
        $result = $this->uploadFileRenameReplace($_file, $_destinationPath, $_replace);
      }
      else
      {
        $result = $this->uploadFileRename($_file, $_destinationPath);
      }
    }
    else
    {
      if ($this->DownloadFromPC($_file, $_destinationPath) == true)
      {
        $result = array('action' => '#fileok#');
      }
      else
      {
        $result = array('action' => '#fileerr#');
      }
    }
    return $result;
  }

  private function uploadFileRenameReplace($_file, $_destinationPath, $_replace = null)
  {
    $result = array('action' => '#fileerr#', 'filename' => null);
    try
    {
      $filename = null;

      if ($this->uploadFileFromPcWithRename($_file, $_destinationPath, $filename, $_replace) == true)
      {
        $result = array('action' => '#fileok#', 'filename' => $filename);
      }
      else
      {
        $result = array('action' => '#fileerr#', 'filename' => $filename);
      }
      return $result;
    }
    catch (Exception $ex)
    {
      return $result;
    }
  }

  private function uploadFileRename($_file, $_destinationPath)
  {
    $result = array('action' => '#fileerr#', 'filename' => null);
    try
    {
      $filename = null;
      if ($this->uploadFileFromPcWithRename($_file, $_destinationPath, $filename) == true)
      {
        $result = array('action' => '#fileok#', 'filename' => $filename);
      }
      else
      {
        $result = array('action' => '#fileerr#', 'filename' => $filename);
      }
      return $result;
    }
    catch (Exception $ex)
    {
      return $result;
    }
  }

  /**
   * Method downloades file from remote server
   * 
   * @param type $_server 
   * @param type $_destinationPath
   * @param type $_destinationFilename
   * @return boolean
   */
  public function DownloadFromServer($_server, $_destinationPath, $_destinationFilename)
  {
    try
    {
      if (file_put_contents($_destinationPath . DIRECTORY_SEPARATOR . $_destinationFilename, fopen($_server, "r")))
      {
        if ($this->CheckFileIsCopied($_destinationPath, $_destinationFilename))
        {
          return true;
        }
        else
        {
          return false;
        }
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  /**
   * Method removes the content from directory
   * 
   * @param type $_dir - Path to directory
   * @return boolean
   */
  public function ClearDir($_dir)
  {
    try
    {
      foreach (new RecursiveIteratorIterator(
      new RecursiveDirectoryIterator($_dir . DIRECTORY_SEPARATOR, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS), RecursiveIteratorIterator::CHILD_FIRST) as $value)
      {
        $value->isFile() ? unlink($value) : rmdir($value);
      }
      return true;
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  /**
   * Method check if file exists
   * 
   * @param type $_destinationPath
   * @param type $_destinationFilename
   * @return boolean
   */
  private function CheckFileIsCopied($_destinationPath, $_destinationFilename)
  {
    if (file_exists($_destinationPath . DIRECTORY_SEPARATOR . $_destinationFilename))
    {
      return true;
    }
    else
    {
      return false;
    }
  }

  /**
   * Method saves file on PC
   * 
   * @param type $_file
   */
  public function DownloadFileOnPC($_file)
  {
    header('Content-Description: File Transfer');
    header('Content-Type: application/octet-stream');
    header('Content-Disposition: attachment; filename=' . basename($_file));
    header('Expires: 0');
    header('Cache-Control: must-revalidate');
    header('Pragma: public');
    header('Content-Length: ' . filesize($_file));
    readfile($_file);
  }

  /**
   * Method saves a text file on PC in text mode
   * 
   * @param type $_file
   */
  public function DownloadTextFileOnPC($_file)
  {

    if (file_exists($_file))
    {
      readfile($_file);
    }
    else
    {
      echo "";
    }
  }

}
