<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Filemanager
 *
 * @author Maciek
 */
class filemanager
{

  public function uploadFile($_files, $_fileoperations=null, $_filters = array(), $_destination = array(), &$_filename)
  {
    if(isset($_fileoperations))
    {
     $_files= call_user_func_array($_fileoperations,array($_files,$_destination));
    }
    $upload = new upload($_files);
    return $upload->prepareuploadFile($_filters, $_destination, $_filename);
  }

  public function uploadFirmwareUpdate($_files, $_destination,&$_filename)
  {
    $upload = new upload($_files);
    return $upload->uploadFirmwareUpdate($_destination,$_filename);
  }

  public function downloadFile($_file)
  {
    $download = new download();
    return $download->DownloadFileOnPC($_file);
  }

  public function downloadFileFromServer($_server, $_destinationPath, $_destinationFilename)
  {
    $download = new download();
    $result = false;
    if ($download->DownloadFileFromServer($_server, $_destinationPath, $_destinationFilename) == true)
    {
      $result = true;
    }
    return $result;
  }

  public function moveAllFilesFromDirToDir($_oldDirPath,$_newDirPath)
  {
    $files = scandir($_oldDirPath);

    if(!is_dir($_newDirPath)){
      mkdir($_newDirPath,0777);
    }

    foreach($files as $file) {
        if($file != '.' && $file != '..') {
            rename($_oldDirPath . DIRECTORY_SEPARATOR . $file, $_newDirPath . DIRECTORY_SEPARATOR . $file);
        }
    }
  }

  public function clearDir($_dir)
  {
    try
    {
      foreach (new RecursiveIteratorIterator(
      new RecursiveDirectoryIterator($_dir . DIRECTORY_SEPARATOR, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS), RecursiveIteratorIterator::CHILD_FIRST) as $value)
      {
        $value->isFile() ? unlink($value) : rmdir($value);
      }
      return true;
    }
    catch (Exception $ex)
    {
      return false;
    }
  }

  public function checkFileCount($_path)
  {
    $filescount = 1;

    if (file_exists($_path))
    {
      $iter = new DirectoryIterator($_path);
      foreach ($iter as $file)
      {
        if ($file->isFile())
        {
          $filescount++;
        }
      }
    }

    return $filescount;
  }

  public function availableStorageSize($_path, $_maxsize)
  {
    $foldersize = 0; //VALUE IN BYTES

    if (file_exists($_path))
    {
      $iter = new DirectoryIterator($_path);
      foreach ($iter as $file)
      {
        if ($file->isFile())
        {
          $foldersize+=$file->getSize();
        }
      }
    }

    return intval($_maxsize - $foldersize);
  }

  public function sumFilesSize($_files)
  {
    $filesize = 0;
    foreach ($_files as $value)
    {

      $filesize+=$value['size'];
    }
    return $filesize;
  }

  public function downloadTextFile($_file)
  {
    $download = new download();
    return $download->DownloadTextFileOnPC($_file);
  }

  public function deleteFile($_file){
      return unlink($_file);
  }

    public function renameFile($_oldname, $_newname) {
        $result = true;
        if (!is_null($_newname)) {
            $result = rename($_oldname, $_newname);
        }
        return $result;

    }

    public function getAllFilesFromDir($_path) {
        $files = array_slice(scandir($_path), 2);
        return $files;
    }

    public function copyFile($_source, $_dest, $_dir) {
        if ($_dir) {
            $files = $this->getAllFilesFromDir($_source);
            foreach ($files as $name) {
                copy($_source . DIRECTORY_SEPARATOR . $name, $_dest . DIRECTORY_SEPARATOR . $name);
            }
        } else {
            return copy($_source, $_dest);
        }
    }

    public function downloadLogs()
    {
      $tmp_logs_tar = '/tmp/maxwell-logs.tar';
      chdir(BACKUP_LOGS_DIR_PATH);
      $gz = new PharData($tmp_logs_tar);
          if ($handle = opendir(BACKUP_LOGS_DIR_PATH)) {
              while (false !== ($entry = readdir($handle))) {
                  if ($entry != "." && $entry != ".." && $entry != ".keep_content.flg" && !is_dir(BACKUP_LOGS_DIR_PATH . $entry)) {
                      $gz->addFile($entry);
                    }
              }
              closedir($handle);
          }
      $gz->addFile(RECENT_MAXWELL_LOG_FILE_PATH, basename(RECENT_MAXWELL_LOG_FILE_PATH));
      $gz->addFile(RECENT_KERNEL_LOG_FILE_PATH, basename(RECENT_KERNEL_LOG_FILE_PATH));
      $gz->compress(Phar::GZ);
      gzclose($gz);
      unset($gz);
      $this->downloadFile($tmp_logs_tar);
      array_map("unlink", glob($tmp_logs_tar . "*"));
    }

    public static function getUserStoragePath($_path)
    {
        return USER_DATA_PATH_PREFIX . $_path;
    }
}
