<?php


/**
 * Description of fileoperations
 *
 * @author hampel_ma
 */
class fileoperations
{
  
  public static function replaceFile($_file)
  {
    $_file = self::cutFilename($_file);
    $_file['file']['name'] = preg_replace("/[^A-Za-z0-9_\.]/", "_", $_file['file']['name']);
    return $_file;
  }
  
  public static function replaceRenameFile($_file, $_path)
  {

    $newfile = self::replaceFile($_file);
    return self::renameFile($newfile, $_path);
  }

  public static function renameFile($_file, $_path)
  {
    if (isset($_path['maxwell']))
    {
      if (preg_match('/.\/pictures+/', $_path['maxwell']))
      {
        $_file = self::cutFilename($_file, MAXIMGFILENAMELENGTH);
      }
      else
      {
        $_file = self::cutFilename($_file);
      }
      $_file['file']['name'] = self::fileNewName($_path, $_file['file']['name']);
    }
    return $_file;
  }

  private static function cutFilename($_file, $_filenamelength = MAXFILENAMELENGTH)
  {
    $matches = array();
    preg_match("/^(.*)\.(.*)$/", $_file['file']['name'], $matches);
    $filesize = strlen($_file['file']['name']);
    $ext = null;
    if ($filesize >= $_filenamelength)
    {
      if (isset($matches[2]))
      {
        $ext = $matches[2];
      }

      $_file = self::newCutNameFile($_file, $matches[1], $ext, $_filenamelength);
    }
    return $_file;
  }

  private static function newCutNameFile($_file, $_name, $_extension = null, $_filenamelength)
  {
    if (!is_null($_extension))
    {
      $endstring = min(strlen($_name), ($_filenamelength - strlen($_extension) - 1));
      if ($endstring > 0)
      {
        $newname = substr($_name, 0, $endstring) . '.' . $_extension;
      }
      else
      {
        http_response_code(500);
        throw new Exception('File error filename < 0 ');
      }
    }
    else
    {
      $endstring = min(strlen($_name), MAXFILENAMELENGTH);
      if ($endstring > 0)
      {
        $newname = substr($_name, 0, $endstring);
      }
    }

    if ($endstring > 0)
    {
      $_file['file']['name'] = $newname;
    }
    return $_file;
  }

  private static function fileNewName($_path, $_filename)
  {
    $pos = strrpos($_filename, '.');
    if ($pos !== false)
    {
      $name = substr($_filename, 0, $pos);
      $ext = substr($_filename, $pos);
    }
    else
    {
      $name = $_filename;
    }

    $newpath = $_path['maxwell'] . '/' . $_filename;
    $newname = $_filename;
    $counter = 0;

    while (file_exists($newpath))
    {
      $newname = $name . '_' . $counter . $ext;
      $newpath = $_path['maxwell'] . '/' . $newname;
      $counter++;
    }

    return $newname;
  }

}
