<?php

function GetSessionToken()
{
    $token = '';
    if (array_key_exists('Authorization', getallheaders()))
    {
        $token = getallheaders()['Authorization'];
        $token = substr($token, 7);
        //remove possible SQL injections
        $token = preg_replace('/[^a-f0-9]/', '', $token);
    }
    return $token;
}

function GET_Text()
{

    $nvm = new settingscontroller();
    $lang = $nvm->settingsGetOneParam('WebUILanguage');
    $str = "";
    if (!is_array($lang) && file_exists(FRONTENDPATH . "/languages/Text_" . $lang))
    {
      $str = file_get_contents(FRONTENDPATH . "/languages/Text_" . $lang);
    }
    else
    {
      $str = file_get_contents(FRONTENDPATH . "/languages/Text_en-us");
    }
    echo $str;
}

function GET_Menu()
{

    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    switch ($userID)
    {
        case USER_NO_SESSION://not autheticated
            echo sessInfo();
            break;
        case USER_REGULAR://user
        case USER_ADMIN://admin
            echo file_get_contents("./Menu");
            break;
    }
}

function GET_Tcpdump()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    $down = new downloadfile();
    if ($userID && $userID == USER_ADMIN)
    {
        $down->DownloadFileOnPC(PCAPPATH);
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

/*
To read PC or LAN port speed please read files:
/sys/class/net/lan/speed
/sys/class/net/pc/speed
values: 10, 100, 1000

To get info about duplex mode:
/sys/class/net/lan/duplex
/sys/class/net/pc/duplex
values: full, half

To get info about plug status read:
/sys/class/net/lan/carrier
/sys/class/net/pc/carrier
values: 0, 1
 */

function GET_NetStatus()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID && ($userID == USER_ADMIN || $userID == USER_REGULAR ))
    {
        $netStatus = array('PCPort','LANPort');
        $netStatus['PCPort'] = array('speed' => null, 'duplex' => null, 'isConnected' => 0);
        $netStatus['LANPort'] = array('speed' => null, 'duplex' => null, 'isConnected' => 0);

        foreach (array('PCPort' => 'pc', 'LANPort' => 'lan') as $key => $value)
        {
            foreach (array('speed' => 'speed', 'duplex' => 'duplex', 'isConnected' => 'carrier') as $paramName => $paramValue)
            {
                if (file_exists('/sys/class/net/' . $value . '/' . $paramValue))
                {
                    $netStatus[$key][$paramName] = file('/sys/class/net/' . $value . '/' . $paramValue, FILE_IGNORE_NEW_LINES);
                }
            }
        }
        echo json_encode($netStatus);
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_ExpertStat()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);

    $DIR_PATH="/data/systemstats/";
    $experStat = array('startup' => NULL, 'reboot' => NULL, 'workingTime' => NULL);

    if ($userID && ($userID == USER_ADMIN || $userID == USER_REGULAR ))
    {
        foreach (array('startup' => $DIR_PATH . "startup.cnt", 'reboot' => $DIR_PATH . "reboot.cnt", 'workingTime' => $DIR_PATH . "working_time.cnt") as $key => $path)
        {
            if (file_exists($path))
            {
                $experStat[$key] = file($path,FILE_IGNORE_NEW_LINES)[0];
            }
        }
        echo json_encode($experStat);
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_SysLog($_args)
{

    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID == USER_ADMIN)
    {
        $matches = array();
        preg_match('/lastLine=(.*)[&$]/', $_args, $matches);
        if (sizeof($matches) > 0)
        {
            $_lastLine = $matches[1];
        }
        preg_match('/lastUpdate=(.*)/', $_args, $matches);
        if (sizeof($matches) > 0)
        {
            $_lastUpdate = $matches[1];
        }
        $debug = new debugManager;
        echo json_encode($debug->getLogs($_lastLine, $_lastUpdate,RECENT_MAXWELL_LOG_FILE_PATH));
    }
    else
    {
        echo sessInfo();
    }
}

function GET_KernelLogs($_args)
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID == USER_ADMIN)
    {
        $matches = array();
        preg_match('/lastLine=(.*)[&$]/', $_args, $matches);
        if (sizeof($matches) > 0)
        {
            $_lastLine = $matches[1];
        }
        preg_match('/lastUpdate=(.*)/', $_args, $matches);
        if (sizeof($matches) > 0)
        {
            $_lastUpdate = $matches[1];
        }
        $debug = new debugManager;
        echo json_encode($debug->getLogs($_lastLine, $_lastUpdate, RECENT_KERNEL_LOG_FILE_PATH));
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_SIPdump()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID && $userID == USER_ADMIN)
    {
        echo shell_exec('tcpdump -AttttnNqr ' . SIPLOGPATH);
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

// function to parse the http auth header
function http_digest_parse($txt)
{
    // protect against missing data
    $needed_parts = array('nonce'=>1, 'nc'=>1, 'cnonce'=>1, 'qop'=>1, 'username'=>1, 'uri'=>1, 'response'=>1);
    $data = array();
    $keys = implode('|', array_keys($needed_parts));

    preg_match_all('@(' . $keys . ')=(?:([\'"])([^\2]+?)\2|([^\s,]+))@', $txt, $matches, PREG_SET_ORDER);

    foreach ($matches as $m)
    {
        $data[$m[1]] = $m[3] ? $m[3] : $m[4];
        unset($needed_parts[$m[1]]);
    }

    return $needed_parts ? false : $data;
}

function GET_Config($path)
{
    $realm = 'Restricted area';
    $users = array('admin' => null);
    $nvm = new settingscontroller();

    $AccessByHTTPEnabled = $nvm->settingsGetPhoneConfigValue('networking.webui.ConfigDownloadViaHttpUrlEnabled');
    if ($AccessByHTTPEnabled !== 'true' )
    {
        http_response_code(404);
        return;
    }

    //this is first get, just respond with nonce
    if (empty($_SERVER['PHP_AUTH_DIGEST']))
    {
        header('HTTP/1.1 401 Unauthorized');
        header('WWW-Authenticate: Digest realm="'.$realm.'",qop="auth",nonce="'.uniqid().'",opaque="'.md5($realm).'"');

        echo $realm;
        return;
    }

    $users['admin'] = $nvm->settingsGetOneParam('AdminPassword');

    // analyze the PHP_AUTH_DIGEST variable
    if (!($data = http_digest_parse($_SERVER['PHP_AUTH_DIGEST']))
            || !isset($users[$data['username']]))
    {
        echo 'Wrong Credentials!';
        return;
    }

    // generate the valid response
    $A1 = md5($data['username'] . ':' . $realm . ':' . $users[$data['username']]);
    $A2 = md5($_SERVER['REQUEST_METHOD'].':'.$data['uri']);
    $valid_response = md5($A1.':'.$data['nonce'].':'.$data['nc'].':'.$data['cnonce'].':'.$data['qop'].':'.$A2);

    //verify if client delivered proper response for valid password
    if ($data['response'] != $valid_response)
    {
        echo 'Wrong Credentials!';
        return;
    }

    $nvmrecv = $nvm->settingsGetProvDump();

    if ($nvmrecv != false)
    {
        header('Content-Type: text/xml');
        echo $nvmrecv;
    }
    else
    {
        http_response_code(404);
        logger::debug("ERROR",__FILE__,__LINE__,"webui get config from property service failed");
    }
}

function GET_Parameters($pathInfo)
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    $nvm = new settingscontroller();
    $resource = explode("/", $pathInfo);
    $resourcelength = count($resource);
    $wildcardparameterinurl = ($resourcelength == 3) ? $resource[2] : null;

    if ($userID)
    {

        if ($resourcelength == 2)
        {
            $nvmrecv = $nvm->settingsGetAllParams($userID);
        }
        else if ($resourcelength == 3 && strpos($pathInfo, '[]') != false)
        {
            $nvmrecv = $nvm->settingsGetArrayValue(substr($wildcardparameterinurl, 0, strpos($wildcardparameterinurl, '[]')), $userID);
        }
        else
        {
            //Exception for Timestamp
            if ($wildcardparameterinurl == 'Timestamp')
            {
                $nvmrecv = $nvm->settingsGetTimestamp();
            }
            else
            {
                $nvmrecv = $nvm->settingsGetOneParam($wildcardparameterinurl);
            }
        }

        if ($nvmrecv != false)
        {
            if(isMaxwell4() && array_key_exists("PhoneSystem", $nvmrecv)){
                $tmpArray = [];
                $availablePhoneSystemOnMax4 = [STANDARD_PHONE_SYSTEM, HYBIRD_120_GE_PHONE_SYSTEM, BROADSOFT_PHONE_SYSTEM];
                foreach ($availablePhoneSystemOnMax4 as $phoneSystem){
                    if (in_array($phoneSystem, $nvmrecv['PhoneSystem']['options'])){
                        array_push($tmpArray, $phoneSystem);
                    }
                }
                $nvmrecv['PhoneSystem']['options'] = $tmpArray;
            }
            $nvmrecv['PhoneConfig']['UsbSupport'] = filter_var($nvm->settingsGetPhoneConfigValue('hardware.usbsupport.Enabled'),FILTER_VALIDATE_BOOLEAN);
            $nvmrecv['PhoneConfig']['ExtMod'] = $nvm->settingsGetPhoneConfigValue("functionkeys.Count");
            $nvmrecv['PhoneConfig']['DoorStation']['advancedOptions'] = filter_var($nvm->settingsGetPhoneConfigValue("doorstation.advancedOptions.Enabled"),FILTER_VALIDATE_BOOLEAN);
            $nvmrecv['PhoneConfig']['TmpHideNonFunctionalParts'] = isMaxwell4() ? true : false;
            $nvmrecv['PhoneConfig']['screenCaptureEnabled'] = filter_var($nvm->settingsGetPhoneConfigValue("ui.screencapture.Enabled"),FILTER_VALIDATE_BOOLEAN);

            if($session->getCurrentLoginUser() == USER_ADMIN )
            {
                $nvmrecv['CertPass']['value'] = ($nvm->settingsGetCertPassword()!=false) ? $nvm->settingsGetCertPassword() : "";
            }

            if (array_key_exists('SIP',$nvmrecv)){
                $ringtonesType = ['RingtoneExternal', 'RingtoneInternal', 'RingtoneGroup','RingtoneDoorStation','RingtoneOptional'];
                foreach($nvmrecv['SIP'] as $indexOfSIPAccount => $sipAccount){
                    foreach ($ringtonesType as $ringtoneType){
                        $nvmrecv['SIP'][$indexOfSIPAccount][$ringtoneType]['value'] = basename($sipAccount[$ringtoneType]['value']);
                    }
                }
            }

            if (array_key_exists('DefaultRingtone',$nvmrecv)) {
                $nvmrecv['DefaultRingtone']['value'] = basename($nvmrecv['DefaultRingtone']['value']);
            }

            echo json_encode($nvmrecv);
        }
        else
        {
            http_response_code(404);
            echo json_encode(array('message' => '#notfound#'));
        }
    }
    else
    {
        if ($token != '')
        {

            if ($session->getCurrentLoginUser() == USER_ADMIN && $token != $session->getToken())
            {
                echo getCodeMess('session', 'admlog');
            }
            else
            {
                echo getCodeMess('session', 'sesserr');
            }
        }
        else //Get params for not validated user
        {
            $nvmrecv = array();

            $nvmrecv['PhoneModel'] =  $nvm->settingsGetOneParamWithProperties('PhoneModel');
            $nvmrecv['PhoneName'] =  $nvm->settingsGetOneParamWithProperties('PhoneName');
            $nvmrecv['Timestamp'] = $nvm->settingsGetTimestamp();
            $nvmrecv['Variant'] =  $nvm->settingsGetOneParamWithProperties('Variant');
            $nvmrecv['WebUILanguage'] =  $nvm->settingsGetOneParamWithProperties('WebUILanguage');

            echo json_encode($nvmrecv);
        }
    }
}

function GET_PhoneSystemDefaultValues() {
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if($userID){

        $paramsArray = ['BLFURL','Broadsoft.BLF.AutomaticFKFilling.Enabled','Broadsoft.BLF.CallPickupCode', 'XSI.Server',
            'XSI.SIPAuthentication','XSI.AuthName', 'XSI.AuthPassword', 'XSI.SearchAnywhereInName.Enabled', 'Broadsoft.Lookup.Incoming',
            'Broadsoft.Lookup.Outgoing', 'XSI.PersonalDirectory.Enabled', 'XSI.PersonalDirectory.Name', 'XSI.GroupDirectory.Enabled',
            'XSI.GroupDirectory.Name', 'XSI.GroupCommonDirectory.Enabled','XSI.GroupCommonDirectory.Name', 'XSI.EnterpriseDirectory.Enabled',
            'XSI.EnterpriseDirectory.Name', 'XSI.EnterpriseCommonDirectory.Enabled', 'XSI.EnterpriseCommonDirectory.Name', 'XSI.CallLogType',
            'Broadsoft.ACD.Enabled', 'Broadsoft.ACD.Status', 'Broadsoft.FlexibleSeating.Enabled','Broadsoft.RemoteOffice.Visible'];

        function joinNameWithPrefix($paramName)
        {
            $prefix = 'Telephony.PhoneSystem.';
            return ($prefix . $paramName);
        }
        $tmpArray = array_map("joinNameWithPrefix", $paramsArray);
        $nvm = new settingscontroller();
        $resp = $nvm->settingsGetVList($tmpArray,PropertyService::getFields()->defaultVal);
        echo json_encode($resp);
    }
}

function GET_State($pathInfo)
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    $nvm = new settingscontroller();
    $resource = explode("/", $pathInfo)[2];
    if ($userID)
    {
        $nvmrecv = $nvm->settingsGetState($resource);
        if ($nvmrecv != false && !is_object($nvmrecv))
        {
            echo json_encode(array($resource => $nvmrecv));
        }
        else
        {
            echo json_encode(array($resource => null));
        }
    }
    else
    {
        echo sessInfo();
    }
}

function GET_SaveLocalPhonebook()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);

    if ($userID && $userID == USER_ADMIN)
    {
        $download = new download();
        return $download->DownloadFileOnPC("/data/internal/localDirectory.xml");
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_SaveAllData()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID && $userID == USER_ADMIN)
    {
        $res = new saverestore();
        if ($res->saveAllDataToFile() === false)
        {
            echo getCodeMess('file', 'savefile');
        }
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_SavePersonalizedData()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID)
    {
        $res = new saverestore();
        if ($res->savePersonalizedDataToFile() != false)
        {
            $res->savePersonalizedDataToFile();
        }
        else
        {
            echo getCodeMess('file', 'savefile');
        }
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}



function GET_Test()
{
    $sett = new settingscontroller();


    echo json_encode($sett->settingsGetAllParams());
}

function GET_SysDump()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID && $userID == USER_ADMIN)
    {
        $savres = new saverestore();
        if ($savres->makeSysDumpZIP() === false)
        {
            echo getCodeMess('sysdump', 'sysdump');
        }
    }
    else
    {
        echo sessInfo();
    }
}

function GET_Ringtones()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID)
    {
        $ringtones = new ringtones();
        echo json_encode($ringtones->getInfoRingtones());
    }
    else
    {
        echo sessInfo();
    }
}

function GET_CallHistory()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID && $userID==USER_ADMIN)
    {
        $ipc = IPC::getInstance();
        $response = $ipc->sendMessageToPhonesystem('{"command": "calllog_getList","response_required": true}');
        if(property_exists($response,'entries') && is_array($response->entries)) {
            uasort($response->entries, function ($a, $b) {
                $timestampA = strtotime($a->startTime);
                $timestampB = strtotime($b->startTime);
                if ($timestampA == $timestampB) {
                    return 0;
                }
                return ($timestampA > $timestampB) ? -1 : 1;
            });
            echo json_encode(array('entries'=>array_slice($response->entries,0,COUNTCALLHISTORYITEMS)));
        }else{
            echo json_encode($response);
        }
    }
    else
    {
        echo sessInfo();
    }
}

function GET_StorageStatus()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID)
    {
        $storageInfo = new storage();
        echo json_encode($storageInfo->getStorageUser());
    }
    else
    {
        echo sessInfo();
    }
}

function GET_Status()
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token);

    if ($userID == USER_REGULAR && $session->isAdminLogged())
    {
        echo getCodeMess('session', 'admlog', 200);
    }
}

function sessInfo()
{
    $token = GetSessionToken();
    $session = new sessionmanager();
    if ($session->getCurrentLoginUser() == USER_ADMIN && $token != $session->getToken())
    {
        return getCodeMess('session', 'admlog');
    }
    else
    {
        return getCodeMess('session', 'sesserr');
    }
}

function GET_Certificates()
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID && $userID == USER_ADMIN)
    {
        $cert = new certificates();
        echo $cert->getInfoCertificates();
    }
    else
    {
        if ($token != '')
        {
            echo sessInfo();
        }
        else
        {
            echo getCodeMess('session', 'sesserr');
        }
    }
}

function GET_InvalidCertificates()
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID)
    {
        $cert = new certificates();
        echo $cert->getInfoInvalidCertificates();
    }
    else
    {
        if ($token != '')
        {
            echo sessInfo();
        }
        else
        {
            echo getCodeMess('session', 'sesserr');
        }
    }
}

function GET_Images()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID)
    {
        $images = new images(USE_WEB_IMAGES_PATH);
        echo json_encode($images->getInfoUserImages());
    }
    else
    {
        echo sessInfo();
    }
}

function GET_Screencaptures()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);

    if ($userID)
    {
        $screencapture = new images(WEBUI_SCREEN_CAPTURE_PATH);
        echo json_encode($screencapture->getInfoUserImages());
    }
    else
    {
        echo sessInfo();
    }
}

function GET_ScreencapturesOnPC($_fileName)
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    $down = new downloadfile();

    if ($userID == USER_ADMIN)
    {
        return $down->DownloadFileOnPC(WEBUI_SCREEN_CAPTURE_PATH . DIRECTORY_SEPARATOR . $_fileName . '.png');
    }
    else
    {
        echo getCodeMess('session', 'sesserr');
    }
}

function GET_Logs(){

    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID == USER_ADMIN) {
        $download = new filemanager();
        $download->downloadLogs();
    }else{
        echo sessInfo();
    }
}

function GET_CoreDumps()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == USER_ADMIN)
  {
    $savres = new saverestore();
    if ($savres->makeCoreDumpsZIP() === false)
    {
        echo getCodeMess('coredumps', 'coredumps');
    }
  }
  else
  {
    echo sessInfo();
  }
}

function GET_WatchdogStats()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == USER_ADMIN)
  {
    if (file_exists(DEVELOPERMODELOCKFILE) && file_exists(WATCHDOGSTATSFILE))
    {
      $myfile = fopen(WATCHDOGSTATSFILE, "r") or die("Unable to open file!");
      echo fread($myfile,filesize(WATCHDOGSTATSFILE));
      fclose($myfile);
    }
    else
    {
      echo "{}";
    }
  }
  else
  {
    echo sessInfo();
  }
}

function GET_Uptime()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    echo shell_exec("uptime | awk -F'( |,|:)+' '{if ($7==\"min\") m=$6; else {if ($7~/^day/) {d=$6;h=$8;m=$9} else {h=$6;m=$7}}} {print d+0\"d\",h+0\"h\",m+0\"m\"}'");
  }
  else
  {
    echo sessInfo();
  }
}

function GET_MacId(){
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if($userID){
        $nvm = new settingscontroller();
        $tmpArray = $nvm->settingsGetVList(['System.Provision.FactoryAuthPassword', 'NET.MAC.Address'], PropertyService::getFields()->all);

        if($tmpArray[0]->webui == 'MACAddress'){
            $macAddr = $tmpArray[0]->value;
            $authPass = $tmpArray[1]->value;
        }else{
            $macAddr = $tmpArray[1]->value;
            $authPass = $tmpArray[0]->value;
        }
        $macId1stPart = strtoupper(str_replace(':','', $macAddr));
        $macId2ndPart = substr($authPass,0,4);

        $macId[] = (object)[
            'key' => "macId",
            'value' => $macId1stPart . '-' . $macId2ndPart
        ];
        echo json_encode($macId);

    }else{
        echo sessInfo();
    }
}

function GET_CurrentTime(){
    $date = new DateTime();
    echo $date->getTimestamp();
}
