<?php
/**
 * Class save a log file into log directory
 *
 * @author hampel_ma
 */
class logger
{
    private static $logLevel = 3;

    const ERROR     = "ERROR";
    const WARNING   = "WARNING";
    const NOTICE    = "NOTICE";
    const INFO      = "INFO";
    const DEBUG     = "DEBUG";

    private static $logLevels = array(
        self::ERROR     => 1,
        self::WARNING   => 2,
        self::NOTICE    => 3,
        self::INFO      => 4,
        self::DEBUG     => 5,
    );

    /**
     * Method add info to log file
     * @param string $_level - Debug level one from ERROR, WARNING, NOTICE, INFO, DEBUG
     * @param string $_file - Name of loged file example use __FILE__ or $variable->getFile() for Catch block
     * @param int $_line - Number of line  example use __LINE__ or $variable->getLine() for Catch block
     * @param string $_message - Message of Log example 'Something' or $variable->getMessage for Catch block
     */
    public static function debug($_level, $_file = null, $_line = null, $_message = null)
    {
        if(!array_key_exists($_level,self::$logLevels) ||
           self::$logLevels[$_level] > self::$logLevel)
        {
            return;
        }

        $log = "[{$_level}] {$_file} {$_line} {$_message}";

        error_log($log);
    }

    public static function logSyslogMessage($_priority, $_message) {
        openlog('PHP', LOG_CONS | LOG_NDELAY | LOG_PID, LOG_USER | LOG_PERROR);
        syslog($_priority, $_message);
        closelog();
    }
}
