<?php

function POST_Language()
{
  $nvm = new settingscontroller();
  $post = json_decode(file_get_contents('php://input'), true);
  if ($nvm->settingsSaveOneParam('WebUILanguage', $post['value']) == true)
  {
    echo getCodeMess('params', 'savepar', 200);
  }
  else
  {
    echo getCodeMess('params', 'savepar');
  }
}

function POST_Parameters()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $nvm = new settingscontroller();
  $req = array();
  $reqarr = json_decode(file_get_contents('php://input'));
  foreach ($reqarr as $key => $value)
  {
    $req[$key] = $value;
  }

  $nvm->settingsCheckAccessParams($req);

  if ($nvm->settingsSaveMultiValue($req) == true)
  {
    if (array_key_exists('IPAddressType', $req) || array_key_exists('IPv4Address', $req))
    {
      $session->logout($userID);
      echo getCodeMess('session', 'logout', 200);
    }
    else
    {
      echo getCodeMess('params', 'savepar', 200);
    }
  }
  else
  {
    echo getCodeMess('params', 'savepar');
  }
}

function POST_CallHistory()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $nvm = new settingscontroller();
  $reqarr = json_decode(file_get_contents('php://input'));

  $ipc = IPC::getInstance();
  if ($reqarr->deleteAll)
  {
      $ipc->sendCustomMessage('web-ui/phone-services', '{"command": "calllog_deleteAllEntries","parameters":{"filter":' .$reqarr->type. '},"response_required":true}');
  }
  else
  {
      foreach ($reqarr->ids as $key => $value)
      {
          $ipc->sendCustomMessage('web-ui/phone-services', '{"command": "calllog_deleteEntry","parameters" : {"id": "' . $value . '"},"response_required":true}');
      }
  }
}

function get_XSI_value($doc, $paramName)
{
  $value = "";
  $nodes = $doc->getElementsByTagName($paramName);

  if ($nodes->length)
  {
    //let's assume we take first occurance only
    $value = $nodes->item(0)->nodeValue;
  }

  return $value;
}

function POST_Broadsoft_Events_User()
{
  $subscriptionId = "";
  $active = "";
  $remoteOfficeNumber = "";

  //get xml
  $doc = new DOMDocument();
  $doc->loadXML(file_get_contents('php://input'));
  //echo $doc->saveHTML();

  $subscriptionId = get_XSI_value($doc, "subscriptionId");
  $active = get_XSI_value($doc, "active");
  $remoteOfficeNumber = get_XSI_value($doc, "remoteOfficeNumber");

  //Always remove 4 chars, because XSI sends remoteOfficeNumber as tel:XXXXXXX E.g tel:02535
  $remoteOfficeNumber = substr($remoteOfficeNumber,4);

  //communicate with phoneservices
  $ipc = IPC::getInstance();
  $message = '
      {
          "command": "remoteOffice_setStatus",
          "parameters": {
                      "subscriptionId" : "' . $subscriptionId . '",
                      "status" : "' . $active . '",
                      "number" : "' . $remoteOfficeNumber . '"
                        },
          "response_required": true
      }';
  $response = $ipc->sendMessageToPhonesystem($message);

  switch ($response->status)
  {
    case "OK":
        http_response_code(200);
      break;
    case "InvalidSubscriptionID":
        http_response_code(403);
      break;
    case "NotBroadsoftSystem":
    default:
        http_response_code(405);//405 Method Not Allowed
  }
}

function POST_Login()
{
  $session = new sessionmanager();

// obtain the JSON of the body of the request
  $post = json_decode(file_get_contents('php://input'));
  $sessionData = $session->login($post->{'password'}, $post->{'login'});

  if ($sessionData)
  {
    //Admin is Login and user try to log
    if ($sessionData != 3)
    {
      http_response_code(200);
      echo json_encode(array("token" => $sessionData['sessionID'], 'type' => $sessionData['type']));
    }
    else
    {
      echo getCodeMess('session', 'admlog');
    }
  }
  else
  {
    echo getCodeMess('session', 'passerr');
  }
}

function POST_Logout()
{
  $session = new sessionmanager();
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    if ($session->logout($userID))
    {
        echo getCodeMess('session', 'logout', 200);
    }
    else
    {
        echo getCodeMess('session', 'logout');
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_State()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $resp = array();
    $post = json_decode(file_get_contents('php://input'), true);

    //Allow setting states for admin only. Except reboot request
    if ($userID == USER_ADMIN || isset($post['System.Reboot']))
    {
      $nvm = new settingscontroller();
      if ($nvm->settingsSetState($post) == true)
      {
          echo getCodeMess('params', 'savestate', 200);
      }
      else
      {
          echo getCodeMess('params', 'savestate');
      }
    }
  }
  else
  {
    echo getCodeMess('params', 'savestate', 400);
  }
}

function POST_LocalPhonebookDownload()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $ipc = IPC::getInstance();
    $ipc->sendMessageToDownloadLocalPhonebook();
    http_response_code(200);
  }
}

function POST_LocalPhonebook($_files)
{
  $session = new sessionmanager;

  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $filename = null;
    $filemanager = new filemanager();
    $nvm = new settingscontroller();
    $contactsDownloadPath = $nvm->settingsGetOneParam('ContactsDownloadPath');
    if (!file_exists($contactsDownloadPath . DIRECTORY_SEPARATOR))
    {
        mkdir($contactsDownloadPath . DIRECTORY_SEPARATOR, 0777, true);
    }
    if (file_exists($contactsDownloadPath . DIRECTORY_SEPARATOR))
    {
        $filemanager->clearDir($contactsDownloadPath);
        if ($filemanager->uploadFirmwareUpdate($_files, $contactsDownloadPath, $filename) == true)
        {
            $fullpath = $contactsDownloadPath . DIRECTORY_SEPARATOR . $filename;
            chmod($fullpath, 0777);
            if ($nvm->settingsSetState(array('LocalDirectoryUpdate.FileName' => $filename,'LocalDirectoryUpdate.Verify' => 'request')))
            {
                echo getCodeMess('phonebook', 'import', 200);
            }
            else
            {
                echo getCodeMess('phonebook', 'import');
            }
        }
        else
        {
            echo getCodeMess('phonebook', 'import', 400);
        }
    }
    else
    {
      echo getCodeMess('phonebook', 'import', 500);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function CMD_RunShellCommand($shellCommand)
{
    $results = exec($shellCommand . " || echo $?");
    return $results;
}

function POST_TransferLocalPhonebook($command)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == USER_ADMIN)
  {
    switch($command)
    {
      case TRANSFER_FROM_USB:
        logger::debug("DEBUG",__FILE__,__LINE__, 'TRANSFER_FROM_USB');
        $results = CMD_RunShellCommand(PHONEBOOK_INSTALLER . ' -import');
          if ($results == "1")
          {
              http_response_code(200);
              echo json_encode(array('message' => '#cmderr#'));
          }
          else
          {
              $ipc = IPC::getInstance();
              $ipc->sendMessageToPhoneUI(array("text" => "configuration_restored"));
              $ipc->sendMessageToPhoneServices(array("command" => "configuration_restored", "parameters"=>array(), "response_required"=>false));
              http_response_code(200);
              echo json_encode(array('message' => '#cmdok#'));
          }
        break;

      case TRANSFER_TO_USB:
        logger::debug("DEBUG",__FILE__,__LINE__, 'TRANSFER_TO_USB');
        $results = CMD_RunShellCommand(PHONEBOOK_INSTALLER . ' -export');
          if ($results == "1")
          {
              http_response_code(200);
              echo json_encode(array('message' => '#cmderr#'));
          }
          else
          {
              http_response_code(200);
              echo json_encode(array('message' => '#cmdok#'));
          }
        break;

      default:;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_RestoreSettings($_files)
{
  $session = new sessionmanager;

  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $res = new saverestore();

    switch ($res->restoreDataFromFile($_files, $userID))
    {
      case STATUS_OK:
          echo getCodeMess('restoresett', 'restoresettings', 200);
          break;
      case STATUS_ERROR:
          echo getCodeMess('restoresett', 'restoresettings', 400);
          break;
      case STATUS_FORBIDDEN:
          echo getCodeMess('restoresett', 'restoresettings', 405);
          break;
      default:
          echo getCodeMess('restoresett', 'restoresettings', 500);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_FirmwareUpdate($_files = null)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == USER_ADMIN)
  {
    $upd = new firmwareupdate();
    if (isset($_files))
    {

      if ($upd->SaveFileFromPC($_files) == true)
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate', 200);
      }
      else
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate');
      }
    }
    else
    {
      if ($upd->DownloadFileFromServer() == true)
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate', 200);
      }
      else
      {
        echo getCodeMess('firmwareupdate', 'firmwareupdate');
      }
    }
  }
  else
  {
    echo getCodeMess('firmwareupdate', 'firmwareupdate', 400);
  }
}

function POST_SysDump()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID && $userID == USER_ADMIN)
  {
    $savres = new saverestore();
    if ($savres->makeSysDump() != false)
    {
      return $savres->makeSysDump();
    }
    else
    {
      echo getCodeMess('sysdump', 'sysdump');
    }
  }
  else
  {
    echo getCodeMess('sysdump', 'sysdump', 400);
  }
}

function POST_Ringtones($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $ring = new ringtones();
    switch ($ring->uploadRingtones($_files))
    {
      case "#filecount#":
        echo getCodeMess('ringtones', 'filecount');
        break;
      case "#filesize#":
        echo getCodeMess('ringtones', 'filesize');
        break;
      case "#mimetype#":
        echo getCodeMess('ringtones', 'filetype');
        break;
      case "#fileok#":
        break;
      case "#fileerr#":
        http_response_code(500);
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_Ringtone()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    $ring = new ringtones();
    if (isset($post['delete']))
    {
      if ($ring->deleteRingtones(array(addslashes($post['delete']))) == false)
      {
        http_response_code(500);
      }
    }
    else if (isset($post['deleteAll']))
    {
      if ($ring->deleteAllRingtones() == false)
      {
        http_response_code(500);
      }
    }
    else if (isset($post['play']))
    {
      $ring->playRingtone($post['play'], $post['group']);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_DeleteAccount()
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if ($userID) {
        $accountManager = new AccountManager($userID);

        $reqParams = json_decode(file_get_contents('php://input'), true);

        if(array_key_exists('accountId',$reqParams)){
            $accountId = $reqParams['accountId'];
            $accountManager->deleteAccount($accountId);
        }else{
            http_response_code(400);
        }
    }
}

function POST_Pin()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    $nvm = new settingscontroller();
    if ($nvm->settingsChangePin(addslashes($post['current']), addslashes($post['new'])))
    {
      http_response_code(200);
    }
    else
    {
      echo '#invalidPin#';
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_Status()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID)
  {
    $post = json_decode(file_get_contents('php://input'), true);
    if (isset($post['alive']) && ($post['alive'] == true))
    {
      $session->updateTimestamp($token);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_Certificates($_files,$_dir = CERTIFICATESDIR, $_withkey = false)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID && $userID == USER_ADMIN)
  {
    $cert = new certificates();
    $result = $cert->uploadCertificate($_files, $_dir, $_withkey);
    switch ($result['action'])
    {
      case "#mimetype#":
        echo getCodeMess('certificates', 'filetype');
        break;
      case "#fileok#":
        echo json_encode(array('file' => $result['filename']));
        break;
      case "#fileerr#":
        echo getCodeMess('certificates', 'filetype');
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('certificates', 'certificates');
  }
}

function POST_ClientCertificates($_files)
{
    $session = new sessionmanager;
    $token = GetSessionToken();
    $userID = $session->verifySession($token, false);
    if ($userID == USER_ADMIN)
    {
        if (!file_exists(TMPCERTPATH)) {
            mkdir(TMPCERTPATH);
        }
        $cert = new certificates();
        $filemanager = new filemanager();
        $filename = null;
        $file['file'] = (!empty($_files['cert'])) ? $_files['cert'] : $_files['key'];
        $uploadedfile = TMPCERTPATH . DIRECTORY_SEPARATOR . $file['file']['name'];

        $uploaded = $filemanager->uploadFile($file, null, array('TypeFilters' => unserialize(CERTIFICATEMIMETYPE)), array('maxwell' => TMPCERTPATH), $filename);

        $lastFile =isset($_POST["isLastFile"]) ? $_POST["isLastFile"]: false;
        $fileType = (isset($_POST["fileType"]) &&  $_POST["fileType"] =="cert")? "cert": "key";

        if($uploaded == FILEOK) {
            if(!file_exists(CERTPASSFILE)){
                file_put_contents(CERTPASSFILE, "");
            }
            $password = (file_exists(CERTPASSFILE))? preg_replace('/\s+/','',file_get_contents(CERTPASSFILE)) : false;
            $result = $cert->convertCert($fileType,$uploadedfile,$password);

            if ($result && $lastFile == 'true') {
                $result = $cert->verifyCert($password);

                if ($result) {
                    $filemanager->renameFile(TMPCERTPATH . DIRECTORY_SEPARATOR .TMPCERT, TMPCERTPATH . DIRECTORY_SEPARATOR . CLIENTCERT);
                    $filemanager->renameFile(TMPCERTPATH . DIRECTORY_SEPARATOR .TMPKEY, TMPCERTPATH . DIRECTORY_SEPARATOR . CLIENTKEY);
                    $filemanager->copyFile(TMPCERTPATH .DIRECTORY_SEPARATOR, CERTCLIENT . DIRECTORY_SEPARATOR, true);
                    $filemanager->clearDir(TMPCERTPATH);
                    $ipc = IPC::getInstance();
                    $ipc->sendMessageToSip(array("command" => "update_tls_security", "parameters"=>array(), "response_required"=>false));

                }
            }

            switch ($result)
            {
                case false:
                    $filemanager->clearDir(TMPCERTPATH);
                    echo getCodeMess('certificates', 'filetype');
                    break;
                case true:
                    echo json_encode(array('file' => $_files['file']['name']));
                    break;
                default:
                    echo getCodeMess('certificates', 'filetype');
                    break;
            }

        }
        else{
            echo getCodeMess('certificates', 'filetype');
        }

    }
    else
    {
        echo getCodeMess('certificates', 'certs');
    }
}

function POST_UploadXML($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token, false);
  if ($userID && $userID == USER_ADMIN)
  {
  $filename = null;
  $down = new filemanager();
  $result = $down->uploadFile($_files, 'fileoperations::replaceFile', array('TypeFilters' => unserialize(XMLMIMETYPE)), array('maxwell' => UPLOADXML), $filename);
  switch ($result)
  {
    case "#mimetype#":
      echo getCodeMess('xml', 'filetype');
      break;
    case "#fileok#":
      http_response_code(200);
      break;
    case "#fileerr#":
      echo getCodeMess('xml', 'filetype');
      break;
    default:
      http_response_code(500);
      break;
  }
  }
  else
  {
      echo getCodeMess('xml', 'xml');

  }
}

function POST_UploadImages($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $img = new images(USE_WEB_IMAGES_PATH);
    switch ($img->uploadImages($_files))
    {
      case "#filecount#":
        echo getCodeMess('images', 'filecount');
        break;
      case "#filesize#":
        echo getCodeMess('images', 'filesize');
        break;
      case "#mimetype#":
        echo getCodeMess('images', 'filetype');
        break;
      case "#fileok#":
        break;
      case "#fileerr#":
        http_response_code(500);
        break;
      default:
        http_response_code(500);
        break;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_DeleteImages($_pictures)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $ring = new images(USE_WEB_IMAGES_PATH);

    if ($ring->deleteImages($_pictures) == false)
    {
      http_response_code(500);
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_ResetPbxFeatureKeys($_keysIndexes)
{
    $session = new sessionmanager();
    $token = GetSessionToken();
    $userID = $session->verifySession($token);
    if($userID){
        $nvm = new settingscontroller();
        $paramArrayToDelete = [];
        foreach ($_keysIndexes['functionKeys'] as $keyIndex){
            array_push($paramArrayToDelete, FUNCTION_KEYS_PREFIX . $keyIndex . '.%');
        }

        foreach ($_keysIndexes['softKeys'] as $keyIndex){
            array_push($paramArrayToDelete, SOFT_KEYS_PREFIX . $keyIndex . '.%');
        }
        $nvm->settingsResetVlist($paramArrayToDelete);
        http_response_code(200);

    }else{
        http_response_code(400);
    }
}

function POST_Screencapture()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $filemanager = new filemanager();
  $ipc = IPC::getInstance();

  $currentAmountOfScreenCaptures = is_dir(WEBUI_SCREEN_CAPTURE_PATH) ? $filemanager->checkFileCount(WEBUI_SCREEN_CAPTURE_PATH) : 0;

  if ($userID == USER_ADMIN &&  $currentAmountOfScreenCaptures <= MAX_SCREEN_CAPTURE_COUNT){
    $ipc->sendMessageToPhoneUiToMakeScreenCapture();
  }
}

function POST_RemoveScreencaptures($_pictures)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);

  if($userID == USER_ADMIN){
    $screenCapture = new images(USE_SCREEN_CAPTURE_PATH);

    if($screenCapture->deleteImages($_pictures) == false){
      http_response_code(500);
    }
  }
}

function POST_UploadSipCert($_files)
{
  $session = new sessionmanager;

  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $res = new sipsecurity();
    $result = $res->uploadSipFile($_files);
    switch ($result['action'])
    {
      case ERRFILETYPE:
        echo getCodeMess('certificates', 'filetype');
        break;
      case FILEOK:
        $nvm = new settingscontroller();

        $req = array('SIPSCertificate' => SIPSECURITYCERTIFICATEDIR.DIRECTORY_SEPARATOR.$result['filename']);
        $nvm->settingsCheckAccessParams($req);

        if ($nvm->settingsSaveMultiValue($req) === true)
        {
          echo json_encode(array('file' => $result['filename']));
        }
        else
        {
          echo getCodeMess('params', 'savepar');
        }

        break;
      case FILEERR:
        echo getCodeMess('certificates', 'filetype');
        break;
      default:
        http_response_code(400);
        break;
    }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}
function POST_RemoveSipCertificate()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $SipCertificatePath = SIPSECURITYCERTIFICATEDIR.DIRECTORY_SEPARATOR.SIPSECURITYCERTIFICATENAME;
  if ($userID && $userID == USER_ADMIN)
  {
    if (file_exists($SipCertificatePath))
    {
      if (unlink($SipCertificatePath))
      {
        $nvm = new settingscontroller();

        $req = array('SIPSCertificate' => 0);
        $nvm->settingsCheckAccessParams($req);

        if ($nvm->settingsSaveMultiValue($req) === true) {
          sendHeader(200, 'File deleted', 0);
        }
      }
      else
      {
        sendHeader(500, 'File not exists', 0);
      }
    }
    else
    {
      sendHeader(404, 'File not exists', 0);
    }
  }
  else
  {
    sendHeader(401, 'Bad request', 0);
  }
}

function POST_UploadSipPrivateKey($_files)
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  if ($userID)
  {
    $res = new sipsecurity();
    $result = $res->uploadSipPrivateKeyFile($_files);
      switch ($result['action'])
      {
        case ERRFILETYPE:
          echo getCodeMess('certificates', 'filetype');
          break;
        case FILEOK:
          $nvm = new settingscontroller();
          $req = array('SIPSPrivateKey' => SIPSECURITYCERTIFICATEDIR.DIRECTORY_SEPARATOR.$result['filename']);
          $nvm->settingsCheckAccessParams($req);

          if ($nvm->settingsSaveMultiValue($req) === true)
          {
            echo json_encode(array('file' => $result['filename']));
          }
          else
          {
            echo getCodeMess('params', 'savepar');
          }
          break;
        case FILEERR:
          echo getCodeMess('certificates', 'filetype');
          break;
        default:
          http_response_code(500);
          break;
      }
  }
  else
  {
    echo getCodeMess('session', 'sesserr');
  }
}

function POST_RemoveSipPrivateKey()
{
  $session = new sessionmanager;
  $token = GetSessionToken();
  $userID = $session->verifySession($token);
  $SipPrivateKeyPath = SIPSECURITYCERTIFICATEDIR.DIRECTORY_SEPARATOR.SIPSECURITYPRIVATEKEYNAME;
  if ($userID && $userID == USER_ADMIN)
  {
    if (file_exists($SipPrivateKeyPath))
    {
      if (unlink($SipPrivateKeyPath))
      {
        $nvm = new settingscontroller();

        $req = array('SIPSPrivateKey' => 0);
        $nvm->settingsCheckAccessParams($req);

        if ($nvm->settingsSaveMultiValue($req) === true) {
          sendHeader(200, 'File deleted', 0);
        }
      }
      else
      {
        sendHeader(500, 'File not exists', 0);
      }
    }
    else
    {
      sendHeader(404, 'File not exists', 0);
    }
  }
  else
  {
    sendHeader(401, 'Bad request', 0);
  }
}
