<?php

class saverestore
{

    private $nvm;

    public function saverestore()
    {
        $this->nvm = new settingscontroller();
    }

    /**
     * Method make zip archive with all settings from nvm
     *
     * @return boolean - If all is ok returns true
     */
    public function saveAllDataToFile()
    {

        if ($this->nvm->settingsCustomRequest(array('method' => METHOD_BACKUP, 'allSettings' => true)))
        {

            return $this->saveDataToArchive();
        }
        else
        {
            return false;
        }
    }

    private function saveDataToArchive()
    {
        try
        {
            //GET FILE FROM DIRECTORIES
            if (file_exists(IMAGEUSERPATH) || file_exists(filemanager::getUserStoragePath(RINGTONESPATH)) || file_exists(INTERNALPATH))
            {
                $this->MakeTmpDirIfNotExists();

                $this->MakeDirIfNotExists(RINGTONESDIRECTORY);
                $this->MakeDirIfNotExists(INTERNALDIRECTORY);
                $this->MakeDirIfNotExists(IMAGEDIRECTORY);

                if ($this->CopyFileToDir(NVMBACKUPFILEPATH, TMPDIR, NVMBACKUPFILE))
                {
                    //COPY IMAGES TO TMP DIRECTORY
                    $this->CopyUserCustomDataDirToTmpDirectory(IMAGEUSERPATH, IMAGEDIRECTORY, $this->ReturnDirContent(IMAGEUSERPATH));

                    //COPY RINGTONES TO TMP DIRECTORY
                    $this->CopyUserCustomDataDirToTmpDirectory(filemanager::getUserStoragePath(RINGTONESPATH),
                        RINGTONESDIRECTORY, $this->ReturnDirContent(filemanager::getUserStoragePath(RINGTONESPATH)));

                    //COPY INTERNAL TO TMP DIRECTORY
                    $this->CopyUserCustomDataDirToTmpDirectory(INTERNALPATH, INTERNALDIRECTORY, $this->ReturnDirContent(INTERNALPATH));
                }
            }
            else
            {
                $this->MakeTmpDirIfNotExists();
                $this->CopyFileToDir(NVMBACKUPFILEPATH, TMPDIR, NVMBACKUPFILE);
            }
            //MAKE ZIP ARCHIVE
            if (shell_exec('zip -P ' . ZIPPASSWORD . ' -r ' . RESTOREZIPARCH . ' ' . TMPDIR . DIRECTORY_SEPARATOR))
            {
                if (file_exists(RESTOREZIPARCH))
                {

                    $down = new filemanager();
                    $down->downloadFile(RESTOREZIPARCH);

                    shell_exec('rm -R ' . TMPDIR . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                    unlink(RESTOREZIPARCH);
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

    /**
     * Method make zip archive with specific users data and with images,ringtones and local contacts
     *
     * @return boolean - If all is ok return true
     */
    public function savePersonalizedDataToFile()
    {
        if ($this->nvm->settingsCustomRequest(array('method' => METHOD_BACKUP,'allSettings'=>false)))
        {
           return $this->saveDataToArchive();
        }
        else
        {
            return false;
        }
    }

    private function isBackupFileCorrect($filePath)
    {
        exec('unzip -Zl ' . $filePath, $output, $ret);

        foreach ($output as $line)
        {
            //check for symlink inside backup file. E.g. lrwxrwxrwx  3.0 unx        4 bx        4 stor 17-Feb-24 13:55 test/etc
            if (preg_match('/^l/', $line))
            {
                logger::debug("WARNING", __FILE__, __LINE__, "webui restore illegal symlink found: " . $line);
                return false;
            }
        }

        return true;
    }

    private function backupContainsOnlyUserParameters($extractedNVMFilePath, $userID)
    {
        $restoredParams = array();
        ini_set("auto_detect_line_endings", true);

        //check backup
        if (($handle = fopen($extractedNVMFilePath, "r")) !== FALSE)
        {
            while (($data = fgetcsv($handle, 1000, ";")) !== FALSE)
            {
                if (count($data) > 1)
                {
                    $restoredParams[$data[0]] = $data[1];
                }
            }
            fclose($handle);
        }
        $nvm = new settingscontroller();

        return $nvm->canRestore($restoredParams, $userID);
    }

    /**
     * Method restore user data form zip archive
     *
     * @param array $_file - Array with info about uploaded file
     * @return boolean - If all is ok returns true
     */
    public function restoreDataFromFile($_file, $userID)
    {
        try
        {
            $down = new filemanager();
            $filename = null;
            $result = $down->uploadFile($_file, 'fileoperations::replaceFile', array(), array('maxwell' => WEBDIR), $filename);
            $uploadedFilePath = '/www' . DIRECTORY_SEPARATOR . $filename;

            if ($result == FILEOK)
            {
                //verify content
                if (!$this->isBackupFileCorrect($uploadedFilePath))
                {
                    unlink($uploadedFilePath);
                    return STATUS_ERROR;
                }
                //UNPACKING ARCHIVE
                exec('unzip -P ' . ZIPPASSWORD . ' ' . $uploadedFilePath . ' -d /www', $output, $ret);

                $extractedNVMFilePath = RESTOREDIRECTORY . DIRECTORY_SEPARATOR . NVMBACKUPFILE;
                if ($userID != USER_ADMIN && !$this->backupContainsOnlyUserParameters($extractedNVMFilePath, $userID))
                {
                    @shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                    @unlink($uploadedFilePath); //DELETE FILE

                    return STATUS_FORBIDDEN;
                }

                if ($ret == 0)
                {
                    //We can't restore data from sysdump file
                    if (file_exists(RESTOREDIRECTORY . DIRECTORY_SEPARATOR . NVMSYSDUMPFILE))
                    {
                        shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                        unlink('/www' . DIRECTORY_SEPARATOR . $_file['file']['name']); //DELETE SYSDUMP ARCHIVE
                        return STATUS_ERROR;
                    }
                    else
                    {
                        $this->CopyTmpToCustomDir(IMAGEDIRECTORY, IMAGEUSERPATH, $this->RestoreUserDataToDirectory(IMAGEDIRECTORY));
                        $this->CopyTmpToCustomDir(RINGTONESDIRECTORY, RINGTONESPATH, $this->RestoreUserDataToDirectory(RINGTONESDIRECTORY));
                        $this->CopyTmpToCustomDir(INTERNALDIRECTORY, INTERNALPATH, $this->RestoreUserDataToDirectory(INTERNALDIRECTORY));

                        if ($this->CopyFileToDir(RESTOREDIRECTORY, NVMBACKUPFILEPATH, NVMBACKUPFILE) && file_exists(NVMBACKUPFILEPATH . DIRECTORY_SEPARATOR . NVMBACKUPFILE))
                        {

                            $ipc = IPC::getInstance();
                            $ipc->sendMessageToPhoneUI(array("text" => "configuration_restored"));
                            $ipc->sendMessageToPhoneServices(array("command" => "configuration_restored", "parameters"=>array(), "response_required"=>false));

                            if ($this->nvm->settingsCustomRequest(array('method' => METHOD_RESTORE, 'allSettings' => true)))
                            {
                                @shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                                @unlink($uploadedFilePath); //DELETE FILE
                                return STATUS_OK;
                            }
                        }
                    }
                }
            }

            if (file_exists($uploadedFilePath))
            {
                @shell_exec('rm -R ' . '/www/www' . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                @unlink($uploadedFilePath);
            }
            return STATUS_ERROR;
        }
        catch (ZMQException $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return STATUS_ERROR;
        }
    }

    private function RestoreUserDataToDirectory($_dir)
    {
        try
        {
            if (file_exists(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR))
            {
                foreach (new RecursiveIteratorIterator(
                             new RecursiveDirectoryIterator(CUSTOMDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR, FilesystemIterator::SKIP_DOTS | FilesystemIterator::UNIX_PATHS), RecursiveIteratorIterator::CHILD_FIRST) as $value)
                {
                    $value->isFile() ? unlink($value) : rmdir($value);
                }
                return new DirectoryIterator(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_dir);
            }
            else
            {
                return array();
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return array();
        }
    }

    /**
     * Method get the users passwords from web database
     *
     * @return string|boolean - If all is ok returns data with users pass else false
     */
    private function GetPassForWeb()
    {
        try
        {
            try
            {
                $sql = new SQLite3(WEBDB);
                $sql->busyTimeout(10000);
                $query = "SELECT password FROM webui_users";
                $result = $sql->query($query);
                $data = '';

                while ($row = $result->fetchArray())
                {
                    $data.=base64_encode($row['password']) . "\n";
                }

                $sql->close();

                return $data;
            }
            catch (Exception $ex)
            {
                return false;
            }
        }
        catch (Exception $ex)
        {
            return false;
        }
    }

    public function makeSysDump()
    {
        try
        {
            if ($this->nvm->settingsCustomRequest(array('method' => METHOD_GET_SYSTEM_DUMP, 'allSettings' => true)))
            {
                if (file_exists(NVMSYSDUMPFILEPATH . DIRECTORY_SEPARATOR . NVMSYSDUMPFILE))
                {
                    $this->nvm->settingsSetState(array('System.Sysdump' => 'request', 'allSettings' => true));
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

    public function makeSysDumpZIP()
    {
        try
        {
            if ($this->nvm->settingsCustomRequest(array('method' => METHOD_GET_SYSTEM_DUMP, 'allSettings'=>false)))
            {
                $this->MakeTmpDirIfNotExists();

                if ($this->CopyFileToDir(NVMSYSDUMPFILEPATH, TMPDIR, NVMSYSDUMPFILE))
                {
                    //MAKE ZIP ARCHIVE
                    $filelocal = SYSDUMPZIPARCH . '_' . $this->nvm->settingsGetOneParam('MACAddress') . '.zip';
                    if (shell_exec('zip -P ' . ZIPPASSWORDSYSDUMP . ' -r ' . $filelocal . ' ' . TMPDIR . DIRECTORY_SEPARATOR))
                    {
                        if (file_exists($filelocal))
                        {
                            $down = new filemanager();
                            $down->downloadFile($filelocal);

                            shell_exec('rm -R ' . TMPDIR . DIRECTORY_SEPARATOR); //DELETE TMP DIRECTORY
                            unlink($filelocal);
                            return true;

                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

    private function CopyUserCustomDataDirToTmpDirectory($_sourcepath, $_destinationpath, $_dirobject)
    {
        try
        {
            $result = false;
            if (file_exists(TMPDIR . DIRECTORY_SEPARATOR . $_destinationpath . DIRECTORY_SEPARATOR))
            {
                $countallfiles = 0;
                $copysuccess = 0;
                foreach ($_dirobject as $value)
                {
                    if ($value->isDot() == false)
                    {
                        if ($value->isFile())
                        {
                            $countallfiles++;
                        }

                        if (copy($_sourcepath . DIRECTORY_SEPARATOR . $value->getFilename(), TMPDIR . DIRECTORY_SEPARATOR . $_destinationpath . DIRECTORY_SEPARATOR . $value->getFilename()))
                        {
                            $copysuccess++;
                        }
                    }
                }
                if ($countallfiles == $copysuccess)
                {
                    $result = true;
                }
            }
            return $result;
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

    private function CopyFileToDir($_sourcepath, $_destinationpath, $_filename)
    {
        if (copy($_sourcepath . DIRECTORY_SEPARATOR . $_filename, $_destinationpath . DIRECTORY_SEPARATOR . $_filename))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    private function ReturnDirContent($_dir)
    {
        return file_exists($_dir) ? new DirectoryIterator($_dir) : array();
    }

    private function MakeDirIfNotExists($_dir)
    {
        if (!file_exists(TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR))
        {
            mkdir((TMPDIR . DIRECTORY_SEPARATOR . $_dir . DIRECTORY_SEPARATOR));
        }
    }

    private function MakeTmpDirIfNotExists()
    {
        if (!file_exists(WEBDIR . DIRECTORY_SEPARATOR . 'tmpdir' . DIRECTORY_SEPARATOR))
        {
            mkdir((WEBDIR . DIRECTORY_SEPARATOR . 'tmpdir' . DIRECTORY_SEPARATOR));
        }
    }

    private function CopyTmpToCustomDir($_source, $_destination, $_object)
    {
        foreach ($_object as $val)
        {
            if ($val->isDot() == false)
            {
                copy(WEBDIR . DIRECTORY_SEPARATOR . TMPDIR . DIRECTORY_SEPARATOR . $_source . DIRECTORY_SEPARATOR . $val->getFilename(), $_destination . DIRECTORY_SEPARATOR . $val->getFilename());
            }
        }
    }

    public function makeCoreDumpsZIP()
    {
        try
        {
            //MAKE ZIP ARCHIVE
            if (shell_exec('zip ' . COREDUMPSZIPFILE . ' ' . RECENT_MAXWELL_LOG_FILE_PATH . ' `ls ' . CRASHDIR . DIRECTORY_SEPARATOR . '*.gz`'))
            {
                if (file_exists(COREDUMPSZIPFILE))
                {
                    $down = new filemanager();
                    $down->downloadFile(COREDUMPSZIPFILE);

                    unlink(COREDUMPSZIPFILE);
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

}
