<?php

/**
 * Description of sessionmanager
 *
 * @author hampel_ma
 */

class sessionmanager
{

  private $nvm;
  private $sesskey;
  private $passUser;
  private $passAdmin;
  private $busyTimeout = 10000;
  private $db = WEBDB;
  private $sqlobject;
  private $accountType;
  private $pdo = null;

  public function sessionmanager()
  {
      $this->pdo = new PDO('sqlite:' . $this->db);
      $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
      $this->pdo->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
      $this->nvm = new settingscontroller();
  }

  public function login($_pass, $_login)
  {
    $id = $this->checkLoginData($_pass, $_login);

    if ($id != 0)
    {
      if ($this->canLogin($id))
      {

        $this->sesskey = $this->generateSessId();
        return $this->setSession($id);
      }
      else
      {
        return 3;
      }
    }
    else
    {
      return false;
    }
  }

  private function sqliteObject()
  {

    return $this->sqlobject;
  }

  private function setSession($_id)
  {

    $sql = "update webui_users " .
            "set sessionID = '" . $this->sesskey . "'," .
            "lastAccess=CURRENT_TIMESTAMP" .
            " where userID='" . $_id . "';";

    $ret = $this->pdo->exec($sql);

    if (!$ret)
      return 0;


    return array('sessionID' => $this->sesskey, 'type' => $this->accountType);
  }

  private function checkLoginData($_pass, $_login)
  {

    $this->passUser = $this->nvm->settingsGetOneParam('UserPassword');
    $this->passAdmin = $this->nvm->settingsGetOneParam('AdminPassword');

    //Admin try to login
    if ($this->passAdmin === $_pass && strtolower($_login) == USER_ADMIN_TEXT)
    {
      $this->accountType = 'admin';
      return USER_ADMIN;
    }
    else if ($this->passUser == $_pass && strtolower($_login) == USER_REGULAR_TEXT)//User try to log
    {
      $this->accountType = 'user';
      return USER_REGULAR;
    }
    else
    {
      return USER_NO_SESSION;
    }
  }

  private function canLogin($accessLevel)
  {
    try
    {

      if ($this->getToken() != false)
      {
        $sql = "SELECT CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s',lastAccess) as integer)  as delta FROM webui_users WHERE sessionID <> ''";
        $ret = $this->executeQuery($sql);
        $resp = !empty($ret)? $ret[0] : false;

        if ($resp) {
            if (abs($resp['delta']) > LASTACCESSDELAY) {
                $this->clearSession();
                return true;
            } else {

                if ($accessLevel == USER_ADMIN && $this->getCurrentLoginUser() == USER_REGULAR) {
                    $sql = "SELECT CAST(strftime('%s', CURRENT_TIMESTAMP) as integer) - CAST(strftime('%s',lastAccess) as integer)  as delta FROM webui_users WHERE userID=" . USER_REGULAR;
                    $ret = $this->executeQuery($sql);
                    $resp = !empty($ret)? $ret[0] : false;

                    if (abs($resp['delta']) > LAST_ACCESS_USER_DELAY) {
                        $this->logout(USER_REGULAR);
                    }

                    return True;
                } else {
                    return false;
                }
            }
        } else{
            return false;
        }
      }
      else
      {
        return true;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

  public function logout($userID)
  {
    try
    {
      $sql = "update webui_users set sessionID = null where userID='" . $userID . "';";
      $ret = $this->pdo->exec($sql);
      if ($ret)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

  public function verifySession($_sessid, $_timestampupdate = true)
  {
    try
    {

      $sql = "select userID from webui_users " .
              "where sessionID='" . $_sessid . "';";

      $row = $this->executeQuery($sql);
      if (empty($row))
      {
          return 0;
      }
      else {

          $userId = $row[0]['userID'];


          if ($row && $userId > 0) {
              if ($_timestampupdate == true) {
                  $this->updateTimestamp($_sessid);
              }
              return $userId;
          } else {
              return 0;
          }
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return 0;
    }
  }

  private function generateSessId()
  {
    return hash("sha256", uniqid(mt_rand(), true));
  }

  private function clearSession()
  {
    try
    {
      $sql2 = "UPDATE webui_users SET sessionID=null";

      $ret = $this->pdo->exec($sql2);

      if ($ret)
        return true;
      else
        return false;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
    }
  }

  public function getCurrentLoginUser()
  {
    try
    {
      $sql = "select userID from webui_users WHERE sessionID <> '' ";

      $ret = $this->executeQuery($sql);
      $resp = !empty($ret)? $ret[0] : false;
      if($resp) {
          if ($resp['userID'] != null) {
              return $resp['userID'];
          } else {
              return USER_NO_SESSION;
          }
      } else{
          return USER_NO_SESSION;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return USER_NO_SESSION;
    }
  }

  public function isAdminLogged()
  {
    try
    {
      $sql = "select userID from webui_users WHERE sessionID <> '' AND userID = " . USER_ADMIN;

      $ret = $this->executeQuery($sql);

      return $ret != null;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function updateTimestamp($_seskey)
  {
    try
    {
      $sql = "update webui_users set lastAccess=CURRENT_TIMESTAMP WHERE sessionID='" . $_seskey . "';";
      $ret = $this->pdo->exec($sql);

      if ($ret)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function logoutUser()
  {
    try
    {
      $sql = "update webui_users set sessionID=null WHERE userID=1;";
      $this->openConnection();
      $ret = $this->pdo->exec($sql);

      if ($ret)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }


  public function getToken()
  {
    try
    {
      $sql = "SELECT sessionID FROM webui_users WHERE sessionID <> ''";
      $ret = ($this->executeQuery($sql));
      $resp = !empty($ret)? $ret[0] : false;
        if($resp) {
          if ($resp['sessionID'] != '')
              return $resp['sessionID'];
          else
              return false;
      } else{
          return false;
      }
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }


    private function executeQuery($_query) {
        $result = false;

        try {
            $result = $this->pdo->query($_query);

        } catch (PDOException $ex) {
            syslog(LOG_ERR, 'ERROR: ' . $ex->getMessage());
        }

        return $result->fetchAll();
    }

    public function __destruct() {
        $this->pdo = null;
    }


}
