#!/bin/sh
DESC="tcpdump wrapper for SIP logging"
SIPLOGDIR="/var/volatile/pcap"
SIPLOGPATH=${SIPLOGDIR}/sip.log

HELPER=0

do_start()
{
    if [ ! -d ${SIPLOGDIR} ]; then
        mkdir -p ${SIPLOGDIR}
    fi
    tcpdump -nqt -s 0 -A -i eth0 port 5060 > ${SIPLOGPATH} &


    #tcpdump -npqt -s 0 -A -i eth0 port 5060 -c 10 -W 100 -w ${SIPLOGPATH} &
    #tcpdump -nqt -s 0 -A -i eth0 port 5060 -c 1 -W 100 -w /var/volatile/pcap/sip.log --no-promiscuous-mode &
    #172.29.8.35
    #tcpdump -C 50 -W 10 -w filename -i eth1
    propcli set State.Network.PCAP started
}


KILL_LIST="tcpdump"

kill_all_progs()
{
    SIGNAL=$1
    APP_COUNT=0
    echo -ne "Sending '${SIGNAL}' signal to: "
    for APP in ${KILL_LIST}
    do
        PIDOF=`pidof ${APP}`
        if [ $? -eq 0 ]; then
        echo -n "${APP} "
        killall -${SIGNAL} ${APP}
        APP_COUNT=$((APP_COUNT+1))
        fi
    done
    echo -ne "\n"
    return $APP_COUNT
}

do_stop()
{
    kill_all_progs SIGKILL
    propcli set State.Network.PCAP stopped
}

case "$1" in
  start)
    echo "Starting $DESC"
    do_start
    ;;
  stop)
    echo "Stopping $DESC"
    do_stop
    sleep 1
    ;;
  *)
    echo "Usage: $0 {start|stop}" >&2
    exit 1
    ;;
esac

exit 0
