<?php

/**
 * Sip Security upload handling class
 * Author: Marcin Rabczyński <marcin.rabczynski@gigaset.com>
 */
class sipsecurity
{
    public function uploadSipFile($_file)
    {
        return $this->upload($_file, array('TypeFilters' => unserialize(SIPSECURITYCERTIFICATEMIMETYPE)), SIPSECURITYCERTIFICATEDIR, SIPSECURITYCERTIFICATENAME);
    }

    public function uploadSipPrivateKeyFile($_file)
    {
        return $this->upload($_file, null, SIPSECURITYCERTIFICATEDIR, SIPSECURITYPRIVATEKEYNAME);
    }

    private function upload($_file, $filters, $destinationDir, $destinationFilename)
    {
        try {
            $uplo = new filemanager();
            $filename = null;
            $result = $uplo->uploadFile($_file, 'fileoperations::replaceRenameFile', $filters, array('maxwell' => $destinationDir), $filename);
            $sourcePathFile = $destinationDir.DIRECTORY_SEPARATOR.$filename;
            $destinationPathFile = $destinationDir.DIRECTORY_SEPARATOR.$destinationFilename;
            if ($result === FILEOK) {
                if(file_exists($destinationPathFile)) {
                    unlink($destinationPathFile);
                }
                rename($sourcePathFile, $destinationPathFile);
                $filename = $destinationFilename;
                $result = array('action' => FILEOK, 'filename' => $filename);
            } else {
                $result = array('action' => $result, 'filename' => $filename);
            }
            return $result;
        } catch (Exception $ex) {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            $result = array('action' => FILEERR, 'filename' => $destinationFilename);
            return $result;
        }
    }
}