<?php

/**
 * Created by PhpStorm.
 * User: maciej
 * Date: 09.11.17
 * Time: 13:10
 */

class utils
{
    public static function removePasswordFromKey($_keyname, $_password) {
        $key = openssl_pkey_get_private('file:///' . $_keyname, $_password);

        return openssl_pkey_export_to_file($key, $_keyname);;
    }

    public static function addPasswordToKey($_keyname, $_password) {
        $key = openssl_pkey_get_private('file:///' . $_keyname);

        return openssl_pkey_export_to_file($key, $_keyname, $_password);
    }

    public static function concatCertKeyFile($_certfile, $_keyfile, $_filename) {
        $key = file_get_contents($_keyfile);
        $cert = file_get_contents($_certfile);

        $concat = $cert . $key;
        $result = file_put_contents($_filename, $concat);

        if ($result) {
            $filemanager = new filemanager();
            $filemanager->deleteFile($_keyfile);
            $filemanager->deleteFile($_certfile);
            $result = true;
        }

        return $result;
    }

    public static function checkIsCertificateFileWithKey($_file) {
        $return = false;

        try {
            $cert = file_get_contents($_file);
            $return = openssl_pkey_get_private($cert) && openssl_x509_read($cert);

        } catch (Exception $ex) {
            $return = false;
        }

        return $return;
    }

    public static function extractKeyCertFromPemFile($_pathToCert, $_pathToKey) {
        $result = true;

        if (!self::checkIsCertificateFileWithKey($_pathToCert)) {
            return $result;
        }

        try {
            $content = file_get_contents($_pathToCert);

            $result = openssl_pkey_export_to_file($content, $_pathToKey);
            $result &= openssl_x509_export_to_file($content, $_pathToCert);
        } catch (Exception $ex) {
            $result = false;
        }

        return $result;
    }

    public static function getValidTo($_file) {
        $cert = self::parsePemFile($_file);
        return isset($cert['validTo_time_t']) ? $cert['validTo_time_t'] : '';
    }

    public static function getSubject($_file) {
        $cert = self::parsePemFile($_file);

        return isset($cert['subject']['CN']) ? $cert['subject']['CN'] : $cert['subject']['O'];
    }

    private static function parsePemFile($_file) {
        $content = file_get_contents($_file);

        return openssl_x509_parse($content);
    }

}
