<?php

class viewjson implements InvmView
{

    public function viewGetRequestAllParams($_response)
    {
        $tab = $this->prepareResponseTab($_response);
        return $tab;
    }

    public function viewGetTimestamp()
    {
        $date = new DateTime();
        $timestamp = (int) $date->getTimestamp();
        return array('value' => $timestamp, 'flags' => 0, 'validator' => array('regexp' => ''));
    }

    private function prepareResponseTab($_response)
    {
        $tab = array();
        $tmp = array();
        foreach ($_response as $key => $value)
        {
            $tmp = explode(".", $value->webui);
            if (count($tmp)>2)
            {
                $tab[$tmp[0]][$tmp[1]][$tmp[2]] = $this->jsonFile($value);
            }
            else
            {
                $tab[$tmp[0]] = $this->jsonFile($value);
            }
        }

        //sort tables to be converted in json as arrays of objects. Otherwise they may end as objects with properties named by index values converted to string.
        if (array_key_exists('SoftKeys', $tab))
        {
            ksort($tab['SoftKeys']);
        }
        if (array_key_exists('SIP', $tab))
        {
          ksort($tab['SIP']);
        }
        if (array_key_exists('DoorStations', $tab))
        {
          ksort($tab['DoorStations']);
        }
        if (array_key_exists('DiallingPlans', $tab))
        {
          ksort($tab['DiallingPlans']);
        }
        if (array_key_exists('CallBarring', $tab))
        {
          ksort($tab['CallBarring']);
        }
        if (array_key_exists('DnD', $tab))
        {
          ksort($tab['DnD']);
        }
        if (array_key_exists('FunctionKeys', $tab))
        {
          ksort($tab['FunctionKeys']);
        }
        if (array_key_exists('QuickDialKeys', $tab))
        {
          ksort($tab['QuickDialKeys']);
        }
        if (array_key_exists('CallDivertBusy', $tab))
        {
          ksort($tab['CallDivertBusy']);
        }
        if (array_key_exists('CallDivertNoAnswer', $tab))
        {
          ksort($tab['CallDivertNoAnswer']);
        }
        if (array_key_exists('CallDivertAll', $tab))
        {
          ksort($tab['CallDivertAll']);
        }
        if (array_key_exists('ExtMod', $tab))
        {
          ksort($tab['ExtMod']);
        }

        return $tab;
    }

    public function jsonFile($val)
    {
        $return = array();

        $reg = isset($val->regexp) ? array('regexp' => $val->regexp) : array('regexp' => '');

        if (isset($val->range_max) && $val->range_max !== '')
        {
            $reg['max'] = $val->range_max;
            if (isset($val->value))
            {
                $val->value = intval($val->value);
            }
        }

        if (isset($val->range_min) && $val->range_min !=='')
        {
            $reg['min'] = $val->range_min;
            if (isset($val->value))
            {
                $val->value = intval($val->value);
            }
        }

        if ($val->webui === 'SelectedCodecs')
            $return = array(
                'value' => isset($val->value) ? array_map('intval', explode(',', $val->value)) : array(),
                'flags' => intval($val->flags),
                'validator' => $reg,
                'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : ''
            );
        else
        {
            if ($val->webui === 'AvailableCodecs')
                $return = array(
                    'value' => isset($val->value) ? $val->value : '',
                    'flags' => intval($val->flags),
                    'validator' => $reg,
                    'options' => isset($val->enum) ? array_map('intval', explode(',', $val->enum)) : ''
                );
            else
                $return = array(
                    'value' => isset($val->value) ? $val->value : '',
                    'flags' => intval($val->flags),
                    'validator' => $reg,
                    'options' => isset($val->enum) ? explode(',', $val->enum) : ''
                );
        }

        return $return;
    }

    public function viewForOneObject($_response)
    {
        return $_response;
    }

    public function viewGetArrayValue($_response)
    {
        return $this->prepareResponseTab($_response);
    }

    public function viewSaveMultiParams($_resp)
    {
        return $this->viewResponseSaveOneObject($_resp);
    }

    public function viewSaveOneParam($_resp)
    {
        return $this->viewResponseSaveOneObject($_resp);
    }

    public function viewStateForOneObject($_resp)
    {
        return $this->viewResponseSaveOneObject($_resp);
    }

    private function viewResponseSaveOneObject($_resp)
    {
        try
        {
            return true;
            $string = '';
            foreach ($_resp as $val)
            {
                $string.=$val;
            }

            $req = json_decode(trim($string));

            if ($req->status == 'ok')
            {
                return true;
            }
            else
            {
                if (isset($req->param))
                    throw new Exception('Param' . ' ' . $req->param . ' ' . $req->status);
                else
                    throw new Exception('NVM Exception' . ' ' . $req->status);
            }
        }
        catch (Exception $ex)
        {
            $exc = new errorexceptionhandler();
            $exc->getException($ex);
            return false;
        }
    }

    public function viewGetText($_str, $_key)
    {
        $jsontostring = json_decode(trim($_str), true);
        return $jsontostring[$_key];
    }

}
